#include<bits/stdc++.h>
#include "pacman.h"
#define MAXN 500007
using namespace std;

int n,q,a[MAXN],t[MAXN];
long long total;

int power[20],lg[MAXN];
int mins[MAXN][20];

void calc(){
    power[0]=1;
    for(int i=1;i<20;i++)power[i]=power[i-1]*2;
    lg[1]=0;
    for(int i=2;i<MAXN;i++)lg[i]=lg[i/2]+1;
}

int combine(int x,int y){
    if(a[x]>a[y])return x;
    return y;
}

int rmq(int i,int j){
    if(j==0)return i;

    if(mins[i][j]!=0)return mins[i][j];

    mins[i][j]=combine(rmq(i,j-1),rmq(i+power[j-1],j-1));
    return mins[i][j];
}

int getmax(int l,int r){
    int len=r-l+1;
    return combine( rmq(l,lg[len]) , rmq(r-power[lg[len]]+1,lg[len]) );
}

unordered_map<long long,int> dp;

long long hesh(long long a,long long b){
    return a*1000000+b;
}

int ans(int l,int r){
    if(l>r)return 0;

    if(dp[hesh(l,r)]>0)return dp[hesh(l,r)];

    int res=0,pos=getmax(l,r);
    
    res=max(ans(l,pos-1),ans(pos+1,r))+1;
    dp[hesh(l,r)]=res;

    return res;
}

long long solve(const vector<int>& w, const vector<int>& S){
    n=int(w.size()); q=int(S.size());
    
    for(int i=1;i<=n;i++){
        a[i]=w[i-1];
    }
    
    for(int i=1;i<=q;i++){
        t[i]=S[i-1];
    }
    sort(t+1,t+q+1);
    
    calc();
    for(int i=1;i<=q;i++){
        for(int f=i;f<=q;f++){
            total+=ans(t[i],t[f]);
        }
    }

    return total;
}

/*
int main(){
    cout<<solve({1,4,2,3},{1,2,4});
}
*/
