#include <bits/stdc++.h>
#include "lis.h"

using namespace std;

template< class T, class T2 > inline bool chkmin( T& a, const T2& b ){ return a > b ? a = b, 1 : 0; };
template< class T, class T2 > inline bool chkmax( T& a, const T2& b ){ return a < b ? a = b, 1 : 0; };

#ifndef LOCAL
#define cerr if(false) cerr
#endif // LOCAL

#define out(x) #x << " = " << x << "  "
typedef long long ll;

const int MAX_N = 1e6 + 42;
const ll mod = 1e9 + 7;


static int n;
static std::vector<int> sequence;

static long long num_queries = 0;
static long long max_queries = 0;
static int error_flag = 0;

static int lis(const std::vector<int> &p){
	std::vector<int> v;
	for(int x: p){
		auto it = lower_bound(v.begin(), v.end(), x);
		if(it == v.end()){
			v.push_back(x);
		}
		else{
			*it = x;
		}
	}
	return v.size();
}

int get_lis_length(const std::vector<int> &permutation){
	++num_queries;
	max_queries = std::max(max_queries, num_queries);

	if(permutation.size() != n){
		std::cout << -1 << std::endl;
		exit(0);
	}

	std::vector<int> cnt(n);
	for(int i = 0; i < n; ++i){
		if(permutation[i] < 0 || permutation[i] >= n){
			std::cout << -2 << std::endl;
			exit(0);
		}
		++cnt[permutation[i]];
		if(cnt[permutation[i]] >= 2){
			std::cout << -3 << std::endl;
			exit(0);
		}
	}

	std::vector<int> new_seq(n);
	for(int i = 0; i < n; ++i)
		new_seq[i] = sequence[permutation[i]];
	return lis(new_seq);
}





int find_maximum(int n ){
    std::vector< int > ind( n );

    std::iota( ind.begin(), ind.end(), 0 );

    std::vector< int > prev = ind;
    int nas = -1;
    for( int i=1 ; i < n ; i++ ){
        int lisStart = get_lis_length( ind );
        bool oke = false;
        int curr = ind[i];
        cerr << out( i ) << out( lisStart ) << endl;
        for( int j=i-1 ; j >= 0 ; j-- ){
            std::swap( ind[j], ind[j+1] );
            int lisCurr = get_lis_length( ind );

            for( auto l : ind ) cerr << l << " ";
            cerr << endl;
            cerr << out( lisCurr ) << endl;

            if( lisCurr > lisStart ){
                oke = true;
                cerr << " sega e po golqmo " << endl;
                break;
            }
        }
        cerr << out( oke ) << endl;
        if( !oke ){
            cerr << " nqma nalqvo po malko " << endl;;
            nas = curr;
        }
        ind = prev;
    }

    cerr << out( nas ) << endl;
    return nas;
}