#include <algorithm>
#include <iostream>
#include <numeric>
#include <cassert>
#include <vector>

typedef long long llong;
const int MAXN = 100000 + 10;
const llong INF = 1e18;

int n;
int a[MAXN];
llong dp[MAXN];

llong max_prize(std::vector <int> A)
{
    n = A.size();
    for (int i = 1 ; i <= n ; ++i)
    {
        a[i] = A[i - 1];
    }

    llong ans = 0;
    for (int i = n ; i >= 1 ; --i)
    {
        dp[i] = -INF;
        for (int jump = 2 ; i + jump <= n ; ++jump)
        {
            for (int times = 1 ; i + jump * times <= n ; ++times)
            {
                dp[i] = std::max(dp[i], dp[i + jump * times] + 1LL * times * a[i + jump * times]);
            }
        }
    }

    return dp[1];
}
