#include "jumps.h"
#include <bits/stdc++.h>

using namespace std;

const int maxn = 200005;
const long long inf = (1LL << 61);

int n;

int a[maxn];

vector<int> candidates;

long long dp[maxn];

vector<int> divisors[maxn];

long long max_prize(vector<int> A)
{
    n = A.size();

    for (int i = 0; i < n; ++i)
    {
        a[i + 1] = A[i];
    }

    for (int i = 1; i <= n; ++i)
    {
        divisors[i].push_back(i);
    }

    for (int i = 2; i <= n; ++i)
    {
        if (divisors[i].size() == 1)
        {
            for (int j = i + i; j <= n; j += i)
            {
                divisors[j].push_back(i);
            }
        }
    }

    dp[1] = 0;

    for (int i = 2; i <= n; ++i)
    {
        dp[i] = -inf;

        for (int prv = i - 2; prv >= 1; --prv)
        {
            for (int j = 0; j < divisors[i - prv].size(); ++j)
            {
                dp[i] = max(dp[i], dp[prv] + (1LL * ((i - prv) / divisors[i - prv][j])) * (1LL * a[i]));
            }
        }

        //cout << i << " :: " << dp[i] << endl;
    }

    return dp[n];
}
