#include "jumps.h"
#include <bits/stdc++.h>

using namespace std;

const int maxn = 200005;
const long long inf = (1LL << 61);

int n;

int a[maxn];

vector<int> candidates;

long long dp[maxn];

vector<int> divisors[maxn];

long long max_prize(vector<int> A)
{
    n = A.size();

    for (int i = 0; i < n; ++i)
    {
        a[i + 1] = A[i];
    }

    for (int i = 1; i <= n; ++i)
    {
        for (int j = i; j <= n; j += i)
        {
            divisors[j].push_back(i);
        }

        sort(divisors[i].begin(), divisors[i].end());
    }

    dp[1] = 0;

    for (int i = 2; i <= n; ++i)
    {
        dp[i] = -inf;

        for (int prv = i - 2; prv >= max(i - 6000, 1); --prv)
        {
            if (dp[prv] == -inf)
            {
                continue;
            }

            dp[i] = max(dp[i], dp[prv] + (1LL * divisors[i - prv][0]) * (1LL * a[i]));

            if (divisors[i - prv][divisors[(i - prv)].size() - 2] != 1)
            {
                dp[i] = max(dp[i], dp[prv] + (1LL * divisors[i - prv][divisors[(i - prv)].size() - 2]) * (1LL * a[i]));
            }
        }

        //cout << i << " :: " << dp[i] << endl;
    }

    return dp[n];
}
