#include<iostream>
#include<vector>
#include<stack>
#include "jumps.h"

#define MAXN 301
#define MOVES 151

using namespace std;

long long n, dp[MAXN][MOVES][MAXN][2], ans[MAXN];

long long max_prize(vector<int> A)
{
    n = A.size();
    for(int i = 0; i < n; i ++)
    {
        for(int k = 2; k < n; k ++)
        {
            if(i - k >= 0)
            {
                dp[i][1][k][0] = ans[i - k];
                dp[i][1][k][1] = ans[i - k] + A[i];
                ans[i] = max(ans[i], dp[i][1][k][1]);
            }
            for(int m = 2; m <= i / k; m ++)
            {
                //cout<<i<<" "<<k<<" "<<m<<endl;
                dp[i][m][k][0] = dp[i - k][m - 1][k][0];
                dp[i][m][k][1] = ans[i - m * k] + m * A[i];
                ans[i] = max(ans[i], dp[i][m][k][1]);
            }
        }
        //cout<<ans[i]<<endl;
    }
    //cout<<ans[n - 1]<<endl;
    return ans[n - 1];
}
/*int main()
{
    cin>>n;
    for(int i = 0; i < n; i ++)
    {
        cin>>arr[i];
    }
    factorize();
    cout<<ans<<endl;
    return 0;
}
/*
7
1 2 -1 3 100 4 16
*/

