#include<bits/stdc++.h>
#include "pacman.h"

#define MAXN 101

using namespace std;
int n, m, dp[MAXN][MAXN], st[MAXN][14];
unordered_map<long long, int> pos;
vector<int> arr;

void buildST()
{
    for(int i = 0; i < n; i ++)
    {
        st[i][0] = arr[i];
    }
    for(int i = 1; (1 << i) <= n; i ++)
    {
        for(int j = 0; j + (1 << i) <= n; j ++)
        {
            st[j][i] = max(st[j][i - 1], st[j + (1 << (i - 1))][i - 1]);
        }
    }
}
int query(int l, int r)
{
    int sz = (r - l + 1);
    int pw = ceil(log2(sz));
    return max(st[l][pw], st[r - (1 << pw) + 1][pw]);
}
int mem(int l, int r)
{
    //cout<<l<<" "<<r<<endl;
    if(l > r) return -1;
    if(dp[l][r]) return dp[l][r];
    if(l == r)
    {
        dp[l][r] = 1;
        return dp[l][r];
    }
    int ind = pos[query(l, r)];
    //cout<<ind<<" "<<query(l, r)<<endl;
    return dp[l][r] = max(mem(l, ind - 1), mem(ind + 1, r)) + 1;
}
long long solve(const vector<int> &w, const vector<int> &S)
{
    arr = w;
    n = w.size();
    for(int i = 0; i < n; i ++) pos[arr[i]] = i;
    m = S.size();
    buildST();
    /*cout<<query(1, 1)<<endl;
    cout<<query(1, 2)<<endl;
    cout<<query(1, 3)<<endl;
    cout<<query(0, 0)<<endl;
    cout<<query(2, 3)<<endl;*/
    long long ans = 0;
    for(int i = 0; i < S.size(); i ++)
    {
        for(int j = i; j < S.size(); j ++)
        {
            ans += mem(min(S[i], S[j]) - 1, max(S[j], S[i]) - 1);
            //cout<<endings[i]<<" "<<endings[j]<<endl;
            //cout<<dp[endings[i] - 1][endings[j] - 1]<<endl;
            //cout<<endl;
        }
    }
    return ans;
}
/*signed main()
{
    cin>>n>>m;
    for(int i = 0; i < n; i ++)
    {
        cin>>arr[i];
        pos[arr[i]] = i;
    }
    buildST();
    /*
    for(int i = 0; i < m; i ++)
    {
        cin>>endings[i];
    }
    //dp[0][n - 1] = mem(0, n - 1);
    int ans = 0;
    for(int i = 0; i < m; i ++)
    {
        for(int j = i; j < m; j ++)
        {
            ans += mem(min(endings[i], endings[j]) - 1, max(endings[j], endings[i]) - 1);
            //cout<<endings[i]<<" "<<endings[j]<<endl;
            //cout<<dp[endings[i] - 1][endings[j] - 1]<<endl;
            //cout<<endl;
        }
    }
    cout<<ans<<endl;
    return 0;
}
*/
