#include<bits/stdc++.h>
#define MAXN 5001
#include "pacman.h"

using namespace std;
int n, m, st[500001][19];
unordered_map<long long, int> pos;
unordered_map<long long, int> dp;
long long hsh(int a, int b)
{
    return a * 1000000 + b;
}
int query(int l, int r)
{
    int sz = (r - l + 1);
    int pw = ceil(log2(sz)) - 1;
    return max(st[l][pw], st[r - (1 << pw) + 1][pw]);
}
int mem(int l, int r)
{
    if(l > r) return -1;
    if(dp[hsh(l, r)]) return dp[hsh(l,r)];
    if(l == r)
    {
        dp[hsh(l, r)] = 1;
        return dp[hsh(l, r)];
    }
    int ind = pos[query(l, r)];
    return dp[hsh(l, r)] = max(mem(l, ind - 1), mem(ind + 1, r)) + 1;
}
long long solve(const vector<int> &w, const vector<int> &S)
{
    n = w.size();
    for(int i = 0; i < n; i ++)
    {
        st[i][0] = w[i];
    }
    for(int i = 1; (1 << i) <= n; i ++)
    {
        for(int j = 0; j + (1 << i) <= n; j ++)
        {
            st[j][i] = max(st[j][i - 1], st[j + (1 << (i - 1))][i - 1]);
        }
    }
    for(int i = 0; i < n; i ++) pos[w[i]] = i;
    m = S.size();
    //buildST();
    long long ans = 0;
    for(int i = 0; i < S.size(); i ++)
    {
        for(int j = i; j < S.size(); j ++)
        {
            ans += mem(min(S[i], S[j]) - 1, max(S[j], S[i]) - 1);
        }
    }
    return ans;
}
