#include "jumps.h"
#include <iostream>
#include <vector>
using namespace std;
const int MAXN=2e5+10;
const long long INF=1e15;
int least[MAXN];
bool er[MAXN];
long long a[MAXN], dp[MAXN];
void eratosten() {
    for (long long i=2;i<MAXN;i++) {
        if (!er[i]) {
            least[i]=i;
            for (long long j=i*i;j<MAXN;j+=i) {
                if (!er[j]) least[j]=i;
                er[j]=true;
            }
        }
    }
}
long long max_prize(std::vector<int> A) {
    int n=A.size();
    for (int i=0;i<n;i++) a[i]=A[i];
    dp[0]=0;
    dp[1]=-INF;
    eratosten();
    for (int i=2;i<n;i++) {
        dp[i]=-INF;
        for (int j=i-2;j>=0;j--) {
            int dif=i-j;
            long long p=dif/least[dif];
            dp[i]=max(dp[i],dp[j]+a[i]);
            dp[i]=max(dp[i],dp[j]+p*a[i]);
        }
    }
    return dp[n-1];
}
