#include <bits/stdc++.h>
using namespace std;
const long long MAXN = 200;
vector<pair<long long,long long>> make_pairs(const std::vector<int>& S){
    vector<pair<long long,long long>> pairs;
    for(int i = 0; i < S.size(); i++){
        for(int j = i; j < S.size(); j++){
            pair<long long, long long> newPair = make_pair(min(S[i],S[j]),max(S[i],S[j]));
            pairs.push_back(newPair);
        }
    }
    return pairs;
}
long long ans[MAXN][MAXN];
long long func(long long l,long long r, const std::vector<int>& w){
    if(l > r || !(0<= l && l < w.size() && 0 <= r && r < w.size()))return 0;
    if(ans[l][r]!=0)return ans[l][r];
    if(l == r){
        return 1;
    }
    long long maxi = -1, maxiPos;
    for(long long i = l; i <= r; i++){
        if(w[i] > maxi){
            maxi = w[i];
            maxiPos = i;
        }
    }
    long long best = max(func(l,maxiPos-1,w),func(maxiPos+1,r,w)) + 1;
    ans[l][r] = best;
    return best;
}
long long solve(const std::vector<int>& w, const std::vector<int>& S){
   vector<pair<long long, long long>> combinations = make_pairs(S);
   long long ans = 0;
   for(auto x : combinations){
        long long l = x.first - 1, r = x.second - 1;
        //cout << "For " << l << " " << r << endl;
        //cout << "Answer" << " " << func(l,r,w) << endl;
        ans += func(l,r,w);
   }
   return ans;
}

