#include "pacman.h"
#include<bits/stdc++.h>
#define ednl "\n"
using namespace std;

pair<int,int> tree[2000005];
int ans[5004][5004];
void build_tree(vector<int>& w,int l,int r,int now){
    if(l==r){
        tree[now]=make_pair(w[l],l);
        return ;
    }
    int mid=(l+r)/2;
    build_tree(w,l,mid,now*2+1);
    build_tree(w,mid+1,r,now*2+2);
    tree[now]=max(tree[now*2+1],tree[now*2+2]);
}

pair<int,int> find_tree(int l,int r,int L,int R,int now){
    if(l>=L && r<=R)return tree[now];
    if(l>R || r<L)return {-1,-1};

    int mid=(l+r)/2;
    return max(find_tree(l,mid,L,R,now*2+1),find_tree(mid+1,r,L,R,now*2+2));
}

long long solve( vector<int>& w, vector<int>& S){
    int n=w.size(),m=S.size();
    build_tree(w,0,n-1,0);
    for(int i=0;i<n;i++){
        for(int j=0;j+i<n;j++){
            pair<int,int>P=find_tree(0,n-1,j,j+i,0);
            int p=P.second;
            ans[j][j+i]=max(ans[j][p-1],ans[p+1][j+i])+1;
        }
    }

    sort(S.begin(),S.end());
    int otg=0;
    for(int i=0;i<m;i++){
        for(int j=i;j<m;j++){
            otg+=ans[S[i]-1][S[j]-1];
            //cout<<ans[S[i]-1][S[j]-1]<<" "<<S[i]-1<<" "<<S[j]-1<<endl;;
        }
    }
    return otg;
}
