#include "jumps.h"
using namespace std;

const int MAXN = 2e5 + 5;
int n;
long long a[MAXN];

long long rec(int ind)
{
    if (ind < 1) return -2e9;
    if (ind == 1) return 0;
    long long ret = -2e9;

    for (int i = ind-1; i >= 1; i--)
    {
        int dist = ind - i;
        for (int t = 1; t <= dist; t++)
        {
            for (int k = 2; k * t <= dist; k++)
            {
                ret = max(ret, rec(i) + a[ind] * t);
            }
        }
    }
    return ret;
}

long long max_prize(std::vector<int> A)
{
    n = A.size();
    for (int i = 1; i <= n; i++)
        a[i] = A[i-1];

    return rec(n);
}
