#include "jumps.h"
using namespace std;

const int MAXN = 2e5 + 5;
int n;
long long a[MAXN];
long long dp[MAXN];
long long rec(int ind)
{
    if (ind < 1) return -2e9;
    if (ind == 1) return 0;
    if (dp[ind]) return dp[ind];
    long long ret = -2e9;

    for (int i = ind - 1; i >= 1; i--)
    {
        int dist = ind - i;
        for (int k = 2; k <= dist; k++)
        {
            if (dist % k) continue;
            for (long long t = 1; t * k <= dist; t++)
            {
                if (t * k != dist) continue;
                long long tmp = rec(i) + a[ind] * t;
                ret = max(ret, tmp);
            }
        }
    }
    return dp[ind] = ret;
}

long long max_prize(std::vector<int> A)
{
    n = A.size();
    for (long long i = 1; i <= n; i++)
        a[i] = A[i-1];

    return rec(n);
}
