#include<bits/stdc++.h>
#define endl '\n'

using namespace std;
typedef long long ll;

void speed()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
}

const int maxn = 2e5 + 10;
const ll inf = 1e18;

int n;
ll a[maxn], dp[maxn];

void input()
{
    cin >> n;
    for (int i = 1; i <= n; i ++)
        cin >> a[i];
}


int low_div[maxn];
void precompute()
{
    for (int i = 1; i <= n; i ++)
        low_div[i] = - 1;

    for (int i = 2; i <= n; i ++)
        for (int j = i; j <= n; j += i)
            if (low_div[j] == -1)
            low_div[j] = i;
}

void calc_dp()
{
    dp[0] = -inf;
    dp[1] = 0;
    for (int i = 2; i <= n; i ++)
    {
        dp[i] = -inf;
        for (int j = 1; j < i; j ++)
        {
            if (low_div[i - j] == -1)
                continue;
            dp[i] = max(dp[i], dp[j] + (ll)((i - j) / low_div[i - j]) * a[i]);
        }
    }

    cout << dp[n] << endl;
}
void solve()
{
    input();
    precompute();
    calc_dp();
}

int main()
{
    solve();
    return 0;
}
