#include<bits/stdc++.h>


using namespace std;
typedef long long ll;

const int maxn = 2e5 + 10;
const ll inf = 1e18;

int n;
ll a[maxn], dp[maxn];

int low_div[maxn];
vector < ll > primes;
void precompute()
{
    for (int i = 1; i <= n; i ++)
        low_div[i] = - 1;

    for (int i = 2; i <= n; i ++)
    {
        if (low_div[i] != -1)
            continue;
        primes.push_back(i);
        for (int j = i * 2; j <= n; j += i)
            if (low_div[j] == -1)
                low_div[j] = i;
    }
}

ll calc_dp()
{
    dp[0] = -inf;
    dp[1] = 0;
    for (int i = 2; i <= n; i ++)
    {
        dp[i] = -inf;
        for (int jump = 2; jump <= sqrt(n) + 1; jump ++)
        {
            for (int t = jump; jump * t < i; t ++)
            {
                dp[i] = max(dp[i], dp[i - jump * t] + (ll)(t) * a[i]);
            }
        }
        for (ll jump : primes)
        {
            for (int t = 1; jump * t < i; t ++)
            {
                dp[i] = max(dp[i], dp[i - jump * t] + (ll)(t) * a[i]);
            }
        }
        ///cout << dp[i] << " ";
    }
    ///cout << endl;

    return dp[n];
}

ll max_prize(vector < int > vec)
{
    n = vec.size();
    for (int i = 0; i < n; i ++)
        a[i + 1] = vec[i];
    precompute();
    return calc_dp();
}


