#include<bits/stdc++.h>

using namespace std;
typedef long long ll;

void speed()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
}

const int maxn = 5e5 + 10;

int n, m;
int w[maxn];
int s[maxn];
int lc[maxn], rc[maxn], root;
void cartesian()
{
    for (int i = 1; i <= n; i ++)
        lc[i] = rc[i] = -1;
    stack < int > st;
    for (int i = 1; i <= n; i ++)
    {
        while(!st.empty() && w[st.top()] < w[i])
        {
            lc[i] = st.top();
            st.pop();
        }
        st.push(i);
    }

    while(!st.empty())
    {
        st.pop();
    }

    for (int i = n; i > 0; i --)
    {
        while(!st.empty() && w[st.top()] < w[i])
        {
            rc[i] = st.top();
            st.pop();
        }

        st.push(i);
    }
}

int depth[maxn];

struct point
{
    int pos, left_value, right_value;

    point(int _pos = 0, int _left_value = 0, int _right_value = 0)
    {
        pos = _pos;
        left_value = _left_value;
        right_value = _right_value;
    }
};

deque < point > act[maxn];
int max_depth[maxn];
ll dfs(int v)
{
    ll ans = 0;
    max_depth[v] = 1;
    int ld = 0, rd = 0;
    if (lc[v] != -1)
    {
        depth[lc[v]] = depth[v] + 1;
        ans += dfs(lc[v]);
        ld = max_depth[lc[v]];

        for (int i = 0; i < (int)act[lc[v]].size(); i ++)
        {
            act[lc[v]][i].right_value ++;
            if (act[v].size() > 0)
                ans = ans + act[lc[v]][i].right_value;
        }
        max_depth[v] = max(max_depth[v], max_depth[lc[v]] + 1);
    }
    if (rc[v] != -1)
    {
        depth[rc[v]] = depth[v] + 1;
        ans += dfs(rc[v]);
        rd = max_depth[rc[v]];
        for (int i = 0; i < (int)act[rc[v]].size(); i ++)
        {
            act[rc[v]][i].left_value ++;
            if (act[v].size() > 0)
                ans = ans + act[rc[v]][i].left_value;
        }

        max_depth[v] = max(max_depth[v], max_depth[rc[v]] + 1);
    }
    ///cout << "here " << v << " " << ans << endl;
    if (lc[v] != -1 && rc[v] != -1)
    {
        for (point l : act[lc[v]])
            for (point r : act[rc[v]])
            {
                ///cout << "merge " << l.right_value << " " << r.left_value << endl;
                ans = ans + max(l.right_value, r.left_value);
            }
    }

    if (act[v].size() == 1)
    {
        ans ++;
        act[v][0].left_value = 1;
        act[v][0].right_value = 1;
        if (lc[v] != -1)
            act[v][0].left_value = max_depth[lc[v]] + 1;
        if (rc[v] != -1)
            act[v][0].right_value = max_depth[rc[v]] + 1;
    }

    if (lc[v] != -1)
    {
        for (int i = 0; i < (int)act[lc[v]].size(); i ++)
        {
            act[lc[v]][i].right_value = max(act[lc[v]][i].right_value, rd + 1);
        }
        swap(act[lc[v]], act[v]);
        if (act[lc[v]].size() > 0)
            act[v].push_back(act[lc[v]][0]);
    }
    if (rc[v] != -1)
    {
        for (int i = 0; i < (int)act[rc[v]].size(); i ++)
        {
            act[rc[v]][i].left_value = max(act[rc[v]][i].left_value, ld + 1);
        }
        if (act[v].size() > act[rc[v]].size())
        {
            for (point cur : act[rc[v]])
                act[v].push_back(cur);
        }
        else
        {
            swap(act[v], act[rc[v]]);
            for (point cur : act[rc[v]])
                act[v].push_front(cur);
        }
    }
    /**cout << "vertex " << v << endl;
    for (point cur : act[v])
    {
        cout << cur.pos << " " << cur.left_value << " " << cur.right_value << endl;
    }*/
    return ans;
}

ll solve(const vector < int > &values, const vector < int > &my_set)
{
    n = values.size();
    m = my_set.size();

    for (int i = 1; i <= n; i ++)
    {
        w[i] = values[i - 1];
    }
    for (int i = 1; i <= m; i ++)
    {
        s[i] = my_set[i - 1];
    }
    sort(s + 1, s + m + 1);

    cartesian();
    root = 1;
    while(w[root] != n)
        root ++;
    for (int i = 1; i <= m; i ++)
        act[s[i]].push_back(point(i, 0, 0));
    ll ans = dfs(root);

    return ans;


}

