#include<iostream>
#include<vector>
#include<cmath>
#include<algorithm>
#include<queue>
#include<random>
#include<set>
#include<map>
#include "jumps.h"
using namespace std;
const int MAX_N=50;
const long double INF=(1LL<<40);
const int MAX_R=50;
struct line//double
{
    long double m,c;
    long double calc(long double x){return m*x+c;}
    long double intersect(line l){return (c-l.c)/(l.m-m);}
};
vector<line>dp[MAX_R+2][MAX_N];
vector<long double>to[MAX_R+2][MAX_N];
void addline(int x,int rem,line cur)
{
    while(dp[x][rem].size()>=2 && cur.intersect(dp[x][rem].back())<=cur.intersect(dp[x][rem][dp[x][rem].size()-2]))
    {
        to[x][rem].pop_back();
        dp[x][rem].pop_back();
    }
    if(to[x][rem].size()>=1)
    {
        long double dokude=floor(cur.intersect(dp[x][rem].back()));
        to[x][rem].back()=dokude;
    }
    to[x][rem].push_back(INF);
    dp[x][rem].push_back(cur);
}
long double query(int x,int rem,long double where)
{
    int l=0,r=to[x][rem].size()-1;
    int pos;
    while(l<=r)
    {
        int mid=(l+r)/2;
        if(where<=to[x][rem][mid])
        {
            pos=mid;
            r=mid-1;
        }
        else l=mid+1;
    }
    return dp[x][rem][pos].calc(where);
}
long double opt[MAX_R+2][MAX_N];
long double a[MAX_N];
long double dyn[MAX_N];
int n;
long long max_prize(std::vector<int> AA)
{
    n=AA.size();
    for(int i=0;i<n;i++)a[i+1]=AA[i];

    for(int t=1;t<MAX_R;t++)
    {
        for(int i=1;i<=n;i++)
        {
            opt[t][i%t]=-INF;
        }
    }

    for(int i=1;i<=n;i++)
    {
        if(i==1)dyn[i]=0;
        else dyn[i]=-INF;
        /*for(int t=1;t<min(i-1,MAX_R);t++)
        {
            if(opt[t][i%t]!=-INF)dyn[i]=max(dyn[i],opt[t][i%t]+t*a[i]);
        }*/
        for(int x=2;x<min(n-1,MAX_R);x++)
        {
            if(dp[x][i%x].size()>=1)dyn[i]=max(dyn[i],(query(x,i%x,-a[i])+i*a[i])/x);
        }

        /*for(int t=1;t<MAX_R;t++)
        {
            if(i-1>=1)
            {
                opt[t][(i-1)%t]=max(opt[t][(i-1)%t],dyn[i-1]);
            }
        }*/
        for(int x=2;x<min(n-1,MAX_R);x++)
        {
            if(dyn[i]!=-INF)addline(x,i%x,{i,dyn[i]*x});
        }
        //cout<<dyn[i]<<"\n";
    }
    return dyn[n];
}









