#include"pacman.h"
#include<bits/stdc++.h>
using namespace std;
#define MAXN 500007
#define LOG 21
int wi[MAXN];
int s[MAXN],pos[MAXN];
int n,m;
unordered_map<long long, int> dp;
int fen[MAXN][LOG];
int howm[MAXN];
void SetSparse()
{
    for (int q=1;q<=n;q++) fen[q][0]=wi[q];
    for (int w=1;w<LOG;w++)
    {
        for (int q=1;q+(1<<w)-1<=n;q++)
        {
            fen[q][w]=max(fen[q][w-1],fen[q+(1<<(w-1))][w-1]);
        }
    }
    int cur=0;
    for (int q=1;q<=n;q++)
    {
        if ((1<<(cur+1))<q) cur++;
        howm[q]=cur;
    }
}
int maxSparse(int l, int r)
{
    int gol=howm[r-l+1];
    //cout<<l<<" "<<r<<" "<<gol<<" "<<fen[l][gol]<<" "<<fen[r-(1<<gol)+1][gol]<<"\n";;
    return max(fen[l][gol],fen[r-(1<<gol)+1][gol]);
}
int fDP(int l, int r)
{
    if (l==r) return 1;
    if (l>r) return 0;
    if (dp.find(l*1LL*MAXN+r)!=dp.end()) return dp[l*1LL*MAXN+r];
    int p=pos[maxSparse(l,r)];
    //cout<<"dp:"<<l<<" "<<r<<" "<<p<<" "<<maxSparse(l,r)<<"\n";
    long long cur=1+max(fDP(l,p-1),fDP(p+1,r));
    dp[l*1LL*MAXN+r]=cur;
    return cur;
}
long long solve(const std::vector<int>& w, const std::vector<int>& S)
{
    n=w.size();
    m=S.size();
    for (int q=1;q<=n;q++) wi[q]=w[q-1];
    for (int q=1;q<=n;q++) pos[wi[q]]=q;
    SetSparse();
    for (int q=0;q<m;q++) s[q]=S[q];
    long long ans=0;
    for (int q=0;q<m;q++)
    {
        for (int w=q;w<m;w++)
        {
            //cout<<s[q]<<" "<<s[w]<<" "<<ans<<" ";
            ans+=fDP(s[q],s[w]);
            if (s[q]!=s[w]) ans+=fDP(s[w],s[q]);
            //cout<<ans<<"\n";
        }
    }
    return ans;
}
