#include<iostream>
#include<vector>
#include<tuple>
#include<algorithm>
#include "jumps.h"
using namespace std;

vector<tuple<long long, int, int, long long> > dp[100002];

long long max_prize(std::vector<int> A) {
    dp[0].push_back({0, 0, 0, 0});
    dp[1].push_back({0, -1, 0, 0});

    int n = A.size();
    for (int i=2; i<n; i++) {
        for (int j=i-2; j>=0; j--) {
            int k = i - j;
            int nn = dp[j].size();
            for (int l=0; l<nn; l++) {
                long long sum, father;
                int t, k;
                tie(sum, t, kk, father) = dp[j][l];

                if (t == -1) break;
                if (t == 0) { dp[i].push_back({A[i], 1, k, 0}); break; }

                long long sum1 = sum + A[i];
                long long sum2 = father + A[i] * (t + 1);
                dp[i].push_back({sum1, 1, k, sum});
                if (k == kk) {
                    dp[i].push_back({sum2, t + 1, k, father});
                }
            }
        }
    }
    sort(dp[n-1].begin(), dp[n-1].end());
    return get<0>(dp[n-1][dp[n-1].size() - 1]);
}
