#include<iostream>
#include<vector>
#include<tuple>
#include<algorithm>
#include<cmath>
#include "jumps.h"
using namespace std;

vector<tuple<long long, int, int> > dp[100002];

int find_father(int x, int t, int k) {
    x = x - t * k;
    return get<0>(dp[x][dp[x].size() - 1]);
}

void Sort(int i) {
    sort(dp[i].begin(), dp[i].end());
}

long long max_prize(std::vector<int> A) {
    dp[0].push_back({0, 0, 0});
    dp[1].push_back({0, -1, 0});

    int n = A.size();
    for (int i=2; i<n; i++) {
        for (int j=i-2; j>=0; j--) {
            int k = i - j;
            int nn = dp[j].size();
            for (int l=0; l<nn; l++) {
                long long sum, father = 0;
                int t, kk;
                tie(sum, t, kk) = dp[j][l];
                if (k == kk) {
                    father = find_father(j, t, k);
                }

                if (t == -1) break;
                if (t == 0) { dp[i].push_back({A[i], 1, k}); break; }

                long long sum1 = sum + A[i];
                long long sum2 = father + A[i] * (t + 1);
                dp[i].push_back({sum1, 1, k});
                if (k == kk) {
                    dp[i].push_back({sum2, t + 1, k});
                }
            }
        }
        Sort(i);
    }
    sort(dp[n-1].begin(), dp[n-1].end());
    return get<0>(dp[n-1][dp[n-1].size() - 1]);
}
