#include<iostream>
#include<vector>
#include<algorithm>
#include "pacman.h"
using namespace std;

const int MAXN = 5002;
int dp[MAXN][MAXN];

int FindMaxi(int l, int r, const std::vector<int>& w) {
    int maxi = w[l], maxiI = l;
    for (int i=l + 1; i<=r; i++) {
        if (w[i] > maxi) { maxi = w[i]; maxiI = i; }
    }
    return maxiI;
}

long long Calculate(int l, int r, const std::vector<int>& w) {
    if (l > r) return 0;
    if (dp[l][r] != 0) return dp[l][r];
    int start = FindMaxi(l, r, w);

    int sum1 = Calculate(start + 1, r, w) + 1;
    int sum2 = Calculate(l, start - 1, w) + 1;
    return dp[l][r] = max(sum1, sum2);

}

long long solve(const std::vector<int>& w, const std::vector<int>& S) {
    long long sum = 0;
    int n = w.size();
    int m = S.size();
    vector<int> s = S;
    sort(s.begin(), s.end());
    for (int i=0; i<m; i++) {
        for (int j=m-1; j>=i; j--) {
            sum += Calculate(s[i] - 1, s[j] - 1, w);
        }
    }

    return sum;
}

