//it is your desire to work hard

#include<bits/stdc++.h>
#include "pacman.h"
#define pb push_back

using namespace std;

typedef long long ll;
typedef pair<int, int> pii;

const int maxn=5e5+3;
const int mod = 1e9+7;

int n, m;
ll a[maxn];
int tree[4*maxn];
vector<int> s;

void build(int x, int l, int r){
    if(l==r){
        tree[x]=l;
        return ;
    }

    int m=(l+r)/2;
    build(x*2, l, m);
    build(x*2+1, m+1, r);

    if(a[tree[x*2]] > a[tree[x*2+1]]){
        tree[x] = tree[x*2];
    }else{
        tree[x] = tree[x*2+1];
    }
    //cerr<<"best from "<<l<<" to "<<r<<" is "<<tree[x]<<endl;
}

int query(int x, int l, int r, int ql, int qr){
    if(ql<=l and r<=qr) return tree[x];

    int m=(l+r)/2;
    int left=-1, right=-1;

    if(ql<=m) left = query(x*2, l, m, ql, qr);
    if(qr>m) right = query(x*2+1, m+1, r, ql, qr);

    if(left == -1){
        return right;
    }

    if(right==-1){
        return left;
    }

    if(a[left]>=a[right]) return left;

    return right;
}

ll solve(const vector<int>& w, const vector<int>& S){
    for(int i=0; i<w.size(); i++){
        a[i+1]=w[i];
    }
    n=w.size();
    m=S.size();

    build(1, 1, n);

    ll nas=m;
    for(auto x: S){
        s.pb(x);
    }
    sort(s.begin(), s.end());

    for(int i=0; i<m; i++){
        for(int j=i+1; j<m; j++){
            int l=s[i], r=s[j], p=0;
            cerr<<"start "<<s[i]<<" to "<<s[j]<<endl;
            while(true){
                /*if(l==r-1){
                    p+=2;
                    break;
                }*/

                if(l>r) break;

                int curr=query(1, 1, n, l, r);
                //cerr<<"biggest from "<<l<<" "<<r<<" is a["<<curr<<"]="<<a[curr]<<endl;

                if(curr-l <= r-curr){
                    //cerr<<l<<" to "<<r<<", decided to go right"<<endl;
                    l=curr+1;

                }else{
                    //cerr<<l<<" to "<<r<<", decided to go left"<<endl;
                    r=curr-1;
                }

                p++;
            }
            //cerr<<"got "<<p<<" pts"<<endl<<endl;
            nas+=p;
        }
    }

    return nas;

}

