//it is your desire to work hard

#include<bits/stdc++.h>
#include "pacman.h"
#define pb push_back

using namespace std;

typedef long long ll;
typedef pair<int, int> pii;

const int maxn=2e6+3;
const int mod = 1e9+7;

int N, M;
ll a[maxn];
int tree[maxn];
vector<int> s;

void build(int x, int l, int r){
    if(l==r){
        tree[x]=l;
        return ;
    }
    int mid=(l+r)/2;
    build(x*2, l, mid);
    build(x*2+1, mid+1, r);

    if(a[tree[x*2]] >= a[tree[x*2+1]]){
        tree[x] = tree[x*2];
    }else{
        tree[x] = tree[x*2+1];
    }
    //cerr<<"best from "<<l<<" to "<<r<<" is "<<tree[x]<<endl;
}

int query(int x, int l, int r, int ql, int qr){
    if(ql<=l and r<=qr) return tree[x];

    int mid=(l+r)/2;

    int left=-1, right=-1;

    if(ql<=mid) left = query(x*2, l, mid, ql, qr);
    if(qr>mid) right = query(x*2+1, mid+1, r, ql, qr);

    if(left == -1){
        return right;
    }
    if(right==-1){
        return left;
    }

    if(a[left]>a[right]) return left;
    return right;
}

ll solve(const vector<int>& w, const vector<int>& S){
    N=w.size();
    M=S.size();

    for(int i=0; i<N; i++){
        a[i+1]=w[i];
    }
    build(1, 1, N);

    vector<int> v;
    for(int i=0; i<M; i++){
        v.pb(S[i]);
    }

    sort(v.begin(), v.end());

    ll ans=0;
    ans+=M;

    for(int i=0; i<M; i++){
        for(int j=i+1; j<M; j++){
            int cl=v[i], cr=v[j];
            int p=0;

            while(true){
                if(cl>cr) break;
                if(cl==cr-1 or cl==cr){
                    p+=1+(cr-cl);
                    break;
                }

                int curr=query(1, 1, maxn-3, cl, cr);

                if(curr-cl >= cr-curr){
                    cr=curr-1;
                }else{
                    cl=curr+1;
                }

                p++;
            }

            ans+=p;
        }
    }

    return ans;
}

