///#include "Lgrader.cpp"
#include "jumps.h"
#include <iostream>
#include <vector>
#define endl '\n'
using namespace std;

const int MAXN = 200000;
const long long INF = 1e18;

int n;
vector<int> v;
long long curr = 0, ans = -INF;

void go(int pos)
{
    if (pos == n - 1)
    {
        ans = max(ans, curr);
        return;
    }

    for (int t = 1; t <= n; ++ t)
    {
        for (int k = 2; k <= n; ++ k)
        {
            if (pos + t * k < n)
            {
                pos += t * k;
                curr += t * v[pos];
                go(pos);
                curr -= t * v[pos];
                pos -= t * k;
            }
        }
    }
}

long long max_prize(vector<int> A)
{
    v = A;
    n = A.size();
    go(0);
    return ans;
}
