///#include "Lgrader.cpp"
#include "jumps.h"
#include <iostream>
#include <vector>
#define endl '\n'
using namespace std;

const int MAXN = 200000;
const int MAXJUMPS = 2000;
const long long INF = 1e18;

int n;
long long dp[MAXN + 5];
vector<long long> dp2[MAXJUMPS + 5]; /// dp[x][y] - kolko skoka pravq (x), ostatuk mod tozi skok (y)

long long max_prize(vector<int> A)
{
    n = A.size();

    for (int j = 1; j <= MAXJUMPS; ++ j)
    {
        dp2[j].resize(j, -INF);
    }

    dp[1] = 0;
    dp[2] = -INF;
    dp2[1][0] = 0;
    for (int i = 3; i <= n; ++ i)
    {
        for (int j = 1; j <= MAXJUMPS; ++ j) /// kolko skoka pravq
        {
            dp[i] = max(dp[i], dp2[j][i % j] + 1ll * j * A[i - 1]);
            /**else
            {
                for (int k = 2; 1ll * j * k < i; ++ k)
                {
                    dp[i] = max(dp[i], dp[i - j * k] + 1ll * j * A[i - 1]);
                }
            }*/
        }

        for (int j = 1; j <= MAXJUMPS; ++ j)
        {
            dp2[j][i % j] = max(dp2[j][i % j], dp[i - j]);
        }
    }
    return dp[n];
}
