///#include "Lgrader.cpp"
#include "pacman.h"
#include <algorithm>
#include <iostream>
#include <vector>
#define endl '\n'
using namespace std;

int n, m;
const int MAXN = 5000;

int pos[MAXN + 5];
int mx[MAXN + 5][MAXN + 5];
long long ans[MAXN + 5][MAXN + 5];

long long solve(const std::vector<int>& w, const std::vector<int>& S)
{
    n = w.size();
    m = S.size();

    for (int i = 0; i < n; ++ i)
    {
        pos[w[i]] = i;
    }

    for (int d = 0; d < n; ++ d)
    {
        for (int i = 0; i < n - d; ++ i)
        {
            if (d == 0)
            {
                ans[i][i + d] = 1;
                mx[i][i + d] = w[i];
                continue;
            }
            mx[i][i + d] = max(mx[i][i + d - 1], w[i + d]);
            int p = pos[mx[i][i + d]];
            if (p == i) ans[i][i + d] = ans[i + 1][i + d] + 1;
            else if (p == i + d) ans[i][i + d] = ans[i][i + d - 1] + 1;
            else ans[i][i + d] = max(ans[i][p - 1], ans[p + 1][i + d]) + 1;
        }
    }

    long long outp = 0;
    for (int i = 0; i < m; ++ i)
    {
        for (int j = i; j < m; ++ j)
        {
            int x = min(S[i], S[j]), y = max(S[i], S[j]);
            x--; y--;
            outp += ans[x][y];
        }
    }
    return outp;
}
