///#include "Lgrader.cpp"
#include "lis.h"
#include <algorithm>
#include <iostream>
#include <vector>
#define endl '\n'
using namespace std;

const int MAXN = 200;

int get_lis_length(const std::vector<int>& p);

int find_maximum(int n)
{
    vector<int> v;
    for (int i = 0; i < n; ++ i)
    {
        v.push_back(i);
    }

    int mx1 = 0, mx2 = 0, mx = 0;
    for (auto x : v)
    {
        vector<int> v1;
        for (auto y : v)
        {
            if (y != x) v1.push_back(y);
        }
        vector<int> v2 = v1;
        reverse(v2.begin(), v2.end());
        v1.push_back(x);
        v2.push_back(x);
        int ans1 = get_lis_length(v1);
        int ans2 = get_lis_length(v2);
        if (ans1 < ans2) swap(ans1, ans2);
        if (ans1 > mx1)
        {
            mx1 = ans1;
            mx2 = ans2;
            mx = x;
        }
        else if (ans1 == mx1 and ans2 > mx2)
        {
            mx2 = ans2;
            mx = x;
        }
    }
    return mx;
}
