///#include "Lgrader.cpp"
#include "lis.h"
#include <algorithm>
#include <iostream>
#include <random>
#include <vector>
#define endl '\n'
using namespace std;

const int MAXN = 200;

mt19937 rg(1309494);

int get_lis_length(const std::vector<int>& p);

int find_maximum(int n)
{
    vector<int> v;
    for (int i = 0; i < n; ++ i)
    {
        v.push_back(i);
    }

    random_shuffle(v.begin(), v.end());

    int len0 = get_lis_length(v);
    for (int j = 0; j < n; ++ j)
    {
        for (int i = 0; i < n - 1; ++ i)
        {
            swap(v[i], v[i + 1]);
            int len1 = get_lis_length(v);
            if (len0 > len1) swap(v[i], v[i + 1]);
            else if (len0 < len1) continue;
            else if (rg() % 3) swap(v[i], v[i + 1]);
        }
    }
    return v.back();
}
