///#include "Lgrader.cpp"
#include "lis.h"
#include <algorithm>
#include <iostream>
#include <random>
#include <vector>
#define endl '\n'
using namespace std;

const int MAXN = 200;

mt19937 rg(1309494);

int get_lis_length(const std::vector<int>& p);

int find_maximum(int n)
{
    vector<int> v;
    for (int i = 0; i < n; ++ i)
    {
        v.push_back(i);
    }

    int len = get_lis_length(v);
    while (len != 1 and len != n)
    {
        random_shuffle(v.begin(), v.end());
        len = get_lis_length(v);
    }

    if (len == 1) return v.front();
    return v.back();
}
