///#include "Lgrader.cpp"
#include "lis.h"
#include <algorithm>
#include <iostream>
#include <random>
#include <vector>
#define endl '\n'
using namespace std;

const int MAXN = 200;

mt19937 rg(1309494);

int get_lis_length(const std::vector<int>& p);

int find_maximum(int n)
{
    vector<int> v;
    for (int i = 0; i < n; ++ i)
    {
        v.push_back(i);
    }

    random_shuffle(v.begin(), v.end());

    int len = get_lis_length(v);
    while (true)
    {
        bool flag = false;
        for (auto x : v)
        {
            vector<int> v1;
            for (auto y : v)
            {
                if (y != x) v1.push_back(y);
            }
            v1.push_back(x);
            int len1 = get_lis_length(v1);
            if (len1 > len)
            {
                v = v1;
                len = len1;
                flag = true;
                break;
            }
        }
        if (!flag) break;
    }

    while (true)
    {
        vector<int> v1;
        v1.push_back(v.back());
        for (int i = 0; i < n - 1; ++ i)
        {
            v1.push_back(v[i]);
        }
        int len1 = get_lis_length(v1);
        if (len1 >= len)
        {
            v = v1;
            len = len1;
        }
        else return v.back();
    }
}
