#include<bits/stdc++.h>
#define MAXN 200007
using namespace std;

const int bucket=100;

const long long inf=1e15;

long long del[MAXN],n,num;
vector<int> primes;
long long a[MAXN],dp[MAXN],mult[MAXN];
vector<int> bad;
int root[bucket+10][bucket+10];

void eratosthen(){
    for(int i=2;i<=n;i++){
        if(del[i]==0){
            del[i]=i;
            primes.push_back(i);
        }
        for(int f=0;f<primes.size() and i*primes[f]<=n;f++){
            del[i*primes[f]]=primes[f];
        }
    }
    for(int i=2;i<=n;i++){
        mult[i]=i/del[i];
    }
}

struct line{
    long long a,b;

    long long calc(long long x){
        return a*x+b;
    }
};

struct node{
    line best;
    int l,r;
};

node tree[10000007];

void add_node(){
    num++;
    if(num==10000000)cout<<1/0;
    tree[num].best={0,-inf};
}

void update(int v,int l,int r,line p){
    int mid=(l+r)/2;

    if(p.calc(mid)>tree[v].best.calc(mid)){
        swap(tree[v].best,p);
    }

    if(p.calc(l)>tree[v].best.calc(l)){
        if(tree[v].l==0){
            add_node();
            tree[v].l=num;
        }
        update(tree[v].l,l,mid,p);
    }

    if(p.calc(r)>tree[v].best.calc(r)){
        if(tree[v].r==0){
            add_node();
            tree[v].r=num;
        }
        update(tree[v].r,mid+1,r,p);
    }
}

long long getmax(int v,int l,int r,int pos){
    if(v==0)return -inf;

    if(l==r)return tree[v].best.calc(pos);

    int mid=(l+r)/2;
    if(pos<=mid)return max(getmax(tree[v].l,l,mid,pos),tree[v].best.calc(pos));
    else return max(getmax(tree[v].r,mid+1,r,pos),tree[v].best.calc(pos));
}

long long suff[MAXN];

long long max_prize(vector<int> A){
    n=int(A.size());
    eratosthen();

    for(int i=1;i<=n;i++){
        a[i]=A[i-1];
    }

    for(int i=2;i<=n;i++){
        if(del[i]>bucket)bad.push_back(i);
    }

    if(n<=30000){
        dp[n]=0;
        for(int i=n-1;i>=1;i--){
            dp[i]=-inf;
            for(int f=i+2;f<=n;f++){
                dp[i]=max(dp[i],dp[f]+max(a[f]*mult[f-i],a[f]));
            }
        }
    }else{
        for(int i=2;i<=bucket;i++){
            for(int f=0;f<i;f++){
                add_node();
                root[i][f]=num;
            }
        }

        dp[n]=0;
        for(long long f=2;f<=bucket;f++){
            update(root[f][n%f],0,n/2,{a[n],dp[n]+(n/f)*a[n]});
        }
        suff[n]=dp[n]+a[n];

        for(long long i=n-1;i>=1;i--){
            dp[i]=-inf;
            for(long long f=0;f<bad.size() and i+bad[f]<=n;f++){
                dp[i]=max(dp[i],dp[i+bad[f]]+a[i+bad[f]]*mult[bad[f]]);
            }

            for(long long f=2;f<=bucket;f++){
                dp[i]=max(dp[i],getmax(root[f][i%f],0,n/2,-i/f));
            }

            for(long long f=2;f<=bucket;f++){
                update(root[f][i%f],0,n/2,{a[i],dp[i]+(i/f)*a[i]});
            }
            
            if(i!=n-1)dp[i]=max(dp[i],suff[i+2]);
            
            suff[i]=max(suff[i+1],dp[i]+a[i]);
        }
    }

    return dp[1];
}

/*
int main(){
    cout<<max_prize({1,2,-1,3,100})<<"\n";
}

*/