#include<bits/stdc++.h>
#include "pacman.h"
#define MAXN 500007
using namespace std;

int n,q,a[MAXN],t[MAXN];
long long total;

int power[20],lg[MAXN];
int mins[MAXN][20];

void calc(){
    power[0]=1;
    for(int i=1;i<20;i++)power[i]=power[i-1]*2;
    lg[1]=0;
    for(int i=2;i<MAXN;i++)lg[i]=lg[i/2]+1;
}

int combine(int x,int y){
    if(a[x]>a[y])return x;
    return y;
}

int rmq(int i,int j){
    if(j==0)return i;

    if(mins[i][j]!=0)return mins[i][j];

    mins[i][j]=combine(rmq(i,j-1),rmq(i+power[j-1],j-1));
    return mins[i][j];
}

int getmax(int l,int r){
    int len=r-l+1;
    return combine( rmq(l,lg[len]) , rmq(r-power[lg[len]]+1,lg[len]) );
}

stack<int> st;
int prevmax[MAXN],nextmax[MAXN];
int ll[MAXN],rr[MAXN];

void spp(){
    for(int i=1;i<=n;i++){
        prevmax[i]=n+1; ll[i]=0;
        while(!st.empty() and a[st.top()]<a[i]){
            prevmax[i]=st.top();
            st.pop();
        }
        if(!st.empty())ll[i]=st.top();
        st.push(i);
    }
    while(!st.empty())st.pop();
    for(int i=n;i>=1;i--){
        nextmax[i]=0; rr[i]=n+1;
        while(!st.empty() and a[st.top()]<a[i]){
            nextmax[i]=st.top();
            st.pop();
        }
        if(!st.empty())rr[i]=st.top();
        st.push(i);
    }
}

int sum[MAXN];

int all(int x){
    if(x==0 or x==n+1)return 0;
    if(sum[x]>0)return sum[x];

    sum[x]=max(all(prevmax[x]),all(nextmax[x]))+1;
    return sum[x];
}

int ans(int from,int l,int r,int to){
    if(l>r)return 0;

    int res=0,pos=getmax(l,r);
    if(from<=ll[pos] and to>=rr[pos])return all(pos);

    res=max(ans(from,l,pos-1,to),ans(from,pos+1,r,to))+1;

    return res;
}

long long solve(const vector<int>& w, const vector<int>& S){
    n=int(w.size()); q=int(S.size());

    for(int i=1;i<=n;i++){
        a[i]=w[i-1];
    }

    spp();

    for(int i=1;i<=q;i++){
        t[i]=S[i-1];
    }
    sort(t+1,t+q+1);

    calc();

    for(int i=1;i<=q;i++){
        for(int f=i;f<=q;f++){
            total+=ans(t[i],t[i],t[f],t[f]);
        }
    }

    return total;
}

/*
int main(){
    cout<<solve({1,4,2,3},{1,2,4});
}
*/


