#include<bits/stdc++.h>
#include "pacman.h"
#define MAXN 500007
using namespace std;

int n,q,a[MAXN],t[MAXN];
long long total;

int power[20],lg[MAXN];
int mins[MAXN][20];

void calc(){
    power[0]=1;
    for(int i=1;i<20;i++)power[i]=power[i-1]*2;
    lg[1]=0;
    for(int i=2;i<MAXN;i++)lg[i]=lg[i/2]+1;
}

int combine(int x,int y){
    if(a[x]>a[y])return x;
    return y;
}

int rmq(int i,int j){
    if(j==0)return i;

    if(mins[i][j]!=0)return mins[i][j];

    mins[i][j]=combine(rmq(i,j-1),rmq(i+power[j-1],j-1));
    return mins[i][j];
}

int getmax(int l,int r){
    if(l>r)return 0;

    int len=r-l+1;
    return combine( rmq(l,lg[len]) , rmq(r-power[lg[len]]+1,lg[len]) );
}

stack<int> st;
int prevmax[MAXN],nextmax[MAXN];
int ll[MAXN],rr[MAXN];
vector<int> treel[MAXN],treer[MAXN];
int depl[MAXN],depr[MAXN];

void dfsl(int x,int d){
    depl[x]=d;
    for(int i=0;i<treel[x].size();i++){
        dfsl(treel[x][i],d+1);
    }
}

void dfsr(int x,int d){
    depr[x]=d;
    for(int i=0;i<treer[x].size();i++){
        dfsr(treer[x][i],d+1);
    }
}

int sum[MAXN];

int all(int x){
    if(x==0 or x==n+1)return 0;
    if(sum[x]>0)return sum[x];

    sum[x]=max(all(prevmax[x]),all(nextmax[x]))+1;
    return sum[x];
}

void spp(){
    for(int i=1;i<=n;i++){
        prevmax[i]=n+1; ll[i]=0;
        while(!st.empty() and a[st.top()]<a[i]){
            prevmax[i]=st.top();
            st.pop();
        }
        if(!st.empty())ll[i]=st.top();
        st.push(i);
    }

    while(!st.empty())st.pop();

    for(int i=n;i>=1;i--){
        nextmax[i]=0; rr[i]=n+1;
        while(!st.empty() and a[st.top()]<a[i]){
            nextmax[i]=st.top();
            st.pop();
        }
        if(!st.empty())rr[i]=st.top();
        st.push(i);
    }

    for(int i=1;i<=n;i++){
        treel[ll[i]].push_back(i);
    }
    dfsl(0,0);
    for(int i=1;i<=n;i++){
        treer[rr[i]].push_back(i);
    }
    dfsr(n+1,0);
}

pair<int,int> dpl[MAXN][20],dpr[MAXN][20];
bool lil[MAXN][20],lir[MAXN][20];

pair<int,int> ffl(int x,int p){
    if(x==0)return {0,0};
    if(ll[x]==0)return {0,0};
    if(p==0)return {ll[x],all(getmax(ll[x]+1,x-1))+depl[x]};

    if(lil[x][p])return dpl[x][p];
    lil[x][p]=true;

    dpl[x][p]={ ffl(ffl(x,p-1).first,p-1).first, max(ffl(x,p-1).second,ffl(ffl(x,p-1).first,p-1).second) };
    return dpl[x][p];
}

pair<int,int> ffr(int x,int p){
    if(x==n+1)return {n+1,0};
    if(rr[x]==n+1)return {n+1,0};
    if(p==0)return {rr[x],all(getmax(x+1,rr[x]-1))+depr[x]};

    if(lir[x][p])return dpr[x][p];
    lir[x][p]=true;

    dpr[x][p]={ ffr(ffr(x,p-1).first,p-1).first, max(ffr(x,p-1).second,ffr(ffl(x,p-1).first,p-1).second) };
    return dpr[x][p];
}

int calc(int l,int r){
    int pos=getmax(l,r);
    int from=l,to=r,res=1;

    for(int i=19;i>=0;i--){
        if(a[ffr(from,i).first]<=a[pos] and ffr(from,i).first!=n+1){
            res=max(res,ffr(from,i).second-depr[pos]+1);
            from=ffr(from,i).first;
        }
    }

    for(int i=19;i>=0;i--){
        if(a[ffl(to,i).first]<=a[pos] and ffl(to,i).first!=0){
            res=max(res,ffl(to,i).second-depl[pos]+1);
            to=ffl(to,i).first;
        }
    }

    return res;
}

long long solve(const vector<int>& w, const vector<int>& S){
    n=int(w.size()); q=int(S.size());

    for(int i=1;i<=n;i++){
        a[i]=w[i-1];
    }

    spp();

    for(int i=1;i<=q;i++){
        t[i]=S[i-1];
    }
    sort(t+1,t+q+1);

    calc();
    for(int i=1;i<=q;i++){
        for(int f=i;f<=q;f++){
            total+=calc(t[i],t[f]);
        }
    }

    return total;
}

/*
int main(){
    cout<<solve({1,4,2,3},{1,2,4});

    */



