#include<bits/stdc++.h>
#define endl '\n'
#include "pacman.h"

using namespace std;
const int maxn=5e5+10;
long long st[maxn][20];
int ind[maxn];
void sparse_table(vector<int> a)
{
    int lg=log2(a.size());
    for(int i=0;i<a.size();i++)st[i][0]=a[i];
    for(int j=1;j<=lg;j++)
    {
        for(int i=0;i<a.size();i++)
        {
            st[i][j]=max(st[i][j-1],st[i+(1<<(j-1))][j-1]);
        }
    }
}
long long RMQ(int l, int r)
{
    int logQ=log2(r-l+1);
    return max(st[l][logQ],st[r-(1<<logQ)+1][logQ]);
}
long long searchQ(int l, int r, int k)
{
    if(l>r)return k-1;
    //cout<<l<<" "<<r<<endl;
    if(l==r)return k;
    int p=ind[RMQ(l,r)];
    //cout<<p<<endl;
    long long ans=max(searchQ(l,p-1,k+1),searchQ(p+1,r,k+1));
}
long long solve(const std::vector<int>& w, const std::vector<int>& s)
{
   sparse_table(w);
   long long ans=s.size();
   for(int i=0;i<w.size();i++)
   {
       ind[w[i]]=i;
   }
   /*for(int i=0;i<s.size();i++)
   {
       for(int j=i+1;j<s.size();j++)
       {
          //cout<<i<<" "<<j<<endl;
          ans+=searchQ(s[i]-1,s[j]-1,1);
       }

   }*/
   return ans;
}
