#include "jumps.h"
#include <bits/stdc++.h>

using namespace std;

const int maxn = 200005;

int n;

int a[maxn];

vector<int> candidates;

long long dp[maxn];

long long calc(int jump)
{
    for (int i = 1; i <= n; i += jump)
    {
        dp[i] = 0;
    }

    for (int i = 1; i <= n; i += jump)
    {
        for (int prv = i - jump; prv >= 1; prv -= jump)
        {
            dp[i] = max(dp[i], dp[prv] + (1LL * ((i - prv) / jump)) * (1LL * a[i]));
        }
    }

    return dp[n];
}

long long max_prize(vector<int> A)
{
    n = A.size();

    for (int i = 0; i < n; ++i)
    {
        a[i + 1] = A[i];
    }

    for (int i = 2; i <= n - 1; ++i)
    {
        if ((n - 1) % i == 0)
        {
            candidates.push_back(i);
        }
    }

    long long ans = 0;

    for (int i = 0; i < candidates.size(); ++i)
    {
        ans = max(ans, calc(candidates[i]));
    }

    return ans;
}
