#include "jumps.h"
#include <bits/stdc++.h>

using namespace std;

const int maxn = 200005;
const long long inf = (1LL << 61);

int n;

int a[maxn];

vector<int> candidates;

long long dp[maxn];

int minPrimeDivisor[maxn];

long long max_prize(vector<int> A)
{
    n = A.size();

    for (int i = 0; i < n; ++i)
    {
        a[i + 1] = A[i];
    }

    for (int i = 1; i <= n; ++i)
    {
        minPrimeDivisor[i] = i;
    }

    for (int i = 2; i <= n; ++i)
    {
        if (minPrimeDivisor[i] == i)
        {
            for (int j = i + i; j <= n; j += i)
            {
                minPrimeDivisor[j] = min(minPrimeDivisor[j], i);
            }
        }
    }

    dp[1] = 0;
    dp[2] = -inf;

    for (int i = 3; i <= n; ++i)
    {
        dp[i] = -inf;

        for (int prv = i - 2; prv >= 1; --prv)
        {
            for (int jump = 2; jump <= i - prv; ++jump)
            {
                dp[i] = max(dp[i], dp[prv] + (1LL * ((i - prv) / jump)) * (1LL * a[i]));
            }
        }

        //cout << i << " :: " << dp[i] << endl;
    }

    return dp[n];
}
