#include "lis.h"
#include <bits/stdc++.h>

using namespace std;

const int maxn = 205;

vector<int> perm;

int find_maximum(int n)
{
    if (n == 8)
    {
        perm.clear();

        for (int i = 0; i < n; ++i)
        {
            perm.push_back(i);
        }

        do
        {
            if (get_lis_length(perm) == n)
            {
                return perm.back();
            }
        } while (next_permutation(perm.begin(), perm.end()));
    }

    perm.clear();

    for (int i = 0; i < n; ++i)
    {
        perm.push_back(i);
    }

    int lis = get_lis_length(perm);

    for (int i = 0; i < n; ++i)
    {
        for (int j = i + 1; j < n; ++j)
        {
            vector<int> newPerm;

            newPerm.push_back(i);

            for (int k = 0; k < n; ++k)
            {
                if (k != i && k != j)
                {
                    newPerm.push_back(k);
                }
            }

            newPerm.push_back(j);

            int res = get_lis_length(newPerm);

            if (res == 2 + lis || res == n)
            {
                return newPerm.back();
            }

            newPerm.clear();

            newPerm.push_back(j);

            for (int k = 0; k < n; ++k)
            {
                if (k != i && k != j)
                {
                    newPerm.push_back(k);
                }
            }

            newPerm.push_back(i);

            res = get_lis_length(newPerm);

            if (res == 2 + lis || res == n)
            {
                return newPerm.back();
            }
        }
    }
}
