#include "lis.h"
#include <bits/stdc++.h>

using namespace std;

const int maxn = 205;

vector<int> perm;

int find_maximum(int n)
{
    if (n == 8)
    {
        perm.clear();

        for (int i = 0; i < n; ++i)
        {
            perm.push_back(i);
        }

        do
        {
            if (get_lis_length(perm) == n)
            {
                return perm.back();
            }
        } while (next_permutation(perm.begin(), perm.end()));
    }

    perm.clear();

    for (int i = 0; i < n; ++i)
    {
        perm.push_back(i);
    }

    int lis = get_lis_length(perm);

    if (lis == n)
    {
        return n - 1;
    }

    vector<int> candidates;

    for (int i = 0; i < n; ++i)
    {
        vector<int> newPerm;

        for (int j = 0; j < n; ++j)
        {
            if (j != i)
            {
                newPerm.push_back(j);
            }
        }

        newPerm.push_back(i);

        int res = get_lis_length(newPerm);

        bool flag = true;

        for (int j = 0; j < n; ++j)
        {
            if (j == i)
            {
                continue;
            }

            newPerm.clear();

            for (int k = 0; k < n; ++k)
            {
                if (k != i && k != j)
                {
                    newPerm.push_back(k);
                }
            }

            newPerm.push_back(i);
            newPerm.push_back(j);

            if (get_lis_length(newPerm) > res)
            {
                flag = false;
                break;
            }
        }

        if (flag == true)
        {
            return i;
        }
    }

    return n - 1;
}
