#include<iostream>
#include<vector>
#include<stack>
#include "jumps.h"

#define MAXN 200001
#define int long long

using namespace std;

int n, ans;
vector<int> arr;

void check(int p)
{
    //cout<<"p = "<<p<<endl;
    stack<pair<int, int> > mx;
    mx.push({arr[p], p});
    for(int i = 2 * p; i < n; i += p)
    {
        if(mx.top() < make_pair(arr[i], i))
        {
           while(mx.size() && mx.top() < make_pair(arr[i], i)) ///ravni
           {
               mx.pop();
           }
           mx.push({arr[i], i});
        }
        else mx.push({arr[i], i});
    }
    int cur = 0;
    while(mx.size())
    {
        int el = mx.top().first;
        int ind = mx.top().second;
        int indL;
        mx.pop();
        if(mx.size())
        {
            indL = mx.top().second;
        }
        else
        {
            indL = 0;
        }
        //cout<<el<<" "<<(ind - indL) / p<<endl;
        cur += (ind - indL) / p * el;
    }
    //cout<<cur<<endl;
    ans = max(ans, cur);
    //cout<<endl;

}
void factorize()
{
    for(int i = 2; i <= n; i ++)
    {
        if((n - 1) % i == 0)
        {
            check(i);
        }
    }
}
long long max_prize(vector<int> A)
{
    n = A.size();
    arr = A;
    factorize();
    return ans;
}
/*int main()
{
    cin>>n;
    for(int i = 0; i < n; i ++)
    {
        cin>>arr[i];
    }
    factorize();
    cout<<ans<<endl;
    return 0;
}
/*
7
1 2 -1 3 100 4 16
*/

