#include "pacman.h"
#include <iostream>
#include <algorithm>
#include <vector>
using namespace std;
const int MAXN=5e3+2;
const int MAXM=5e5;
int s[MAXM];
int a[MAXN], maxind[MAXN][MAXN];
long long dp[MAXN][MAXN];
int n, m;
long long find_dp(int i, int j) {
    if (i>j) return 0;
    if (dp[i][j]!=-1) return dp[i][j];
    dp[i][j]=1;
    int k=maxind[i][j];
    dp[i][j]+=max(find_dp(i,k-1),find_dp(k+1,j));
    ///cout << i << ' ' << j << ' ' << dp[i][j] << ' ' << k << endl;
    return dp[i][j];
}
long long solve(const vector<int>& w, const vector<int>& S) {
    n=w.size();
    m=S.size();
    for (int i=1;i<=n;i++) a[i]=w[i-1];
    for (int i=0;i<m;i++) s[i]=S[i];
    sort(s,s+m);
    int curi;
    for (int i=1;i<=n;i++) {
        dp[i][i]=1;
        curi=i;
        for (int j=i+1;j<=n;j++) {
            dp[i][j]=-1;
            if (a[curi]<a[j]) curi=j;
            maxind[i][j]=curi;
        }
    }
    long long ans=0;
    for (int i=0;i<m;i++) {
        for (int j=i;j<m;j++) {
            ans+=find_dp(s[i],s[j]);
            //cout << s[i] << ' ' << s[j] << ' ' << ans << endl;
        }
    }
    return ans;
}
