#include "pacman.h"
#include <iostream>
#include <algorithm>
#include <vector>
#include <unordered_map>
using namespace std;
const int MAXN=5e5+2;
int s[MAXN];
int a[MAXN], sp[MAXN][22], stepen[MAXN];
unordered_map <long long, long long> dp;
long long n, m;
int get_max(int l, int r) {
    int i1, i2, st;
    st=stepen[r-l+1];
    i1=sp[l][st];
    i2=sp[r-(1<<st)+1][st];
    if (a[i1]>a[i2]) return i1;
    return i2;
}
long long find_dp(long long i, long long j) {
    if (i>j) return 0;
    long long cur=i*n+j;
    if (dp[cur]!=0) return dp[cur];
    int k=get_max(i,j);
    dp[cur]=1+max(find_dp(i,k-1),find_dp(k+1,j));
    //cout << i << ' ' << j << ' ' << dp[cur] << ' ' << k << endl;
    return dp[cur];
}
void sparce_table() {
    for (int st=1;(1<<st)<=n;st++) {
        for (int i=0;i+(1<<st)<=n;i++) {
            int l, r;
            l=sp[i][st-1]; r=sp[i+(1<<(st-1))][st-1];
            if (a[l]>a[r]) sp[i][st]=l;
            else sp[i][st]=r;
        }
    }
    int st=0;
    for (int i=1;i<=n;i++) {
        if ((1<<st)<i/2) st++;
        stepen[i]=st;
    }
}
long long solve(const vector<int>& w, const vector<int>& S) {
    n=w.size();
    m=S.size();
    for (long long i=0;i<n;i++) {
        a[i]=w[i];
        sp[i][0]=i;
        dp[i*n+i]=1;
    }
    for (int i=0;i<m;i++) s[i]=S[i]-1;
    sort(s,s+m);
    sparce_table();
    long long ans=0;
    for (int i=0;i<m;i++) {
        for (int j=i;j<m;j++) {
            ans+=find_dp(s[i],s[j]);
            //cout << s[i] << ' ' << s[j] << ' ' << ans << endl;
        }
    }
    return ans;
}
