#include <bits/stdc++.h>
#include "pacman.h"
using namespace std;

const int maxn = 5e3+2;
int n, m, a[maxn], dp[maxn][maxn];
struct tree
{
    int maxel;
    int pos;
};
///tree t[4*maxn];
tree maxi[maxn];

/**void make_tree(int i, int l, int r)
{
    if (l == r)
    {
        t[i].maxel = a[r];
        t[i].pos = r;
        return;
    }

    int mid = (l + r) >> 1;
    make_tree(2*i, l, mid);
    make_tree(2*i+1, mid+1, r);

    if (t[2*i].maxel > t[2*i+1].maxel)
    {
        t[i].maxel = t[2*i].maxel;
        t[i].pos = t[2*i].pos;
    }
    else
    {
        t[i].maxel = t[2*i+1].maxel;
        t[i].pos = t[2*i+1].pos;
    }
}

tree find_max(int x, int l, int r, int&i, int&j)
{
    if (l > j || r < i) return {0,0};
    if (l >= i && r <= j)
        return t[x];

    int mid = (l + r) >> 1;
    tree t1 = find_max(2*x, l, mid, i, j);
    tree t2 = find_max(2*x+1, mid+1, r, i, j);

    if (t1.maxel > t2.maxel)
        return t1;
    return t2;
}**/

long long solve(const std::vector<int>& w, const std::vector<int>& S)
{
    n = (int)(w.size());
    int i;
    /**for (i=1; i<=n; ++i)
        a[i] = w[i-1];

    make_tree(1, 1, n);**/
    for (i=1; i<n; ++i)
    {
        dp[i][i] = 1;
        dp[i][i+1] = 2;
        if (w[i-1] > w[i])
        {
            maxi[i].maxel = w[i-1];
            maxi[i].pos = i;
        }
        else
        {
            maxi[i].maxel = w[i];
            maxi[i].pos = i+1;
        }
    }
    dp[n][n] = 1;
    maxi[n].maxel = w[n-1];
    maxi[n].pos = n;

    int l, j, g, pos, newj, newi;
    for (l=3; l<=n; ++l)
    {
        g = n - l + 1;
        for (i=1; i<=g; ++i)
        {
            j = i + l - 1;
            if (maxi[i].maxel < w[j-1])
            {
                maxi[i].maxel = w[j-1];
                maxi[i].pos = j;
            }
            pos = maxi[i].pos;
            ///pos = find_max(1, 1, n, i, j).pos;
            //cout << i << " and " << j << ": " << pos << endl;
            newj = pos - 1;
            newi = pos + 1;
            if (newj < i)
            {
                dp[i][j] = dp[newi][j] + 1;
            }
            else if (newi > j)
            {
                dp[i][j] = dp[i][newj] + 1;
            }
            else
            {
                if (dp[i][newj] > dp[newi][j])
                    dp[i][j] = dp[i][newj] + 1;
                else
                    dp[i][j] = dp[newi][j] + 1;
                //dp[i][j] = max(dp[i][newj], dp[newi][j]) + 1;
            }
            //cout << dp[i][j] << endl;
        }
    }

    long long ans = 0;
    m = (int)(S.size());
    int p1, p2;
    for (i=0; i<m; ++i)
    {
        for (j=i; j<m; ++j)
        {
            p1 = S[i]; p2 = S[j];
            if (p1 > p2)
            {
                p1 = p1 + p2;
                p2 = p1 - p2;
                p1 = p1 - p2;
            }
            ans += (long long)(dp[p1][p2]);
            //cout << p1 << " " << p2 << " " << ans << '\n' ;
        }
    }
    return ans;
}