#include<bits/stdc++.h>
#pragma GCC optimize
#include"jumps.h"
using namespace std;

int n;
long long a[200005];
int primes[20005];
int brprimes=0, pr500=0;
bool zadr[200005]={1, 1};

void Eratosten()
{
    for(int i=2; i*i<=n; i++)
    {
        if(zadr[i]) continue;
        for(int j=i*i; j<=n; j+=i) zadr[j]=1;
    }
    for(int i=2; i<=n; i++)
    {
        if(zadr[i]) continue;
        primes[brprimes]=i;
        brprimes++;
        if(i<450) pr500++;
    }
}

long long dp[200005];
long long mx[200005];
int ost[200005];

struct line
{
    long long koef, pos;
    long long st;
    line() {}
    line(long long a, long long b, long long c)
    {
        koef=a;
        st=b;
        pos=c;
    }
};

vector<line> vr[2005][2005];

void push_line(line x, int i, int j)
{
    long long tsize=vr[i][j].size();
    while(tsize)
    {
        line lastL=vr[i][j][tsize-1];
        if(lastL.st>x.st) return;
        if(lastL.st+lastL.koef*lastL.pos<=x.st+x.koef*lastL.pos) tsize--;
        else break;
    }
    vr[i][j].resize(tsize);
    if(!tsize)
    {
        vr[i][j].push_back(x);
        vr[i][j][0].pos=1e9;
    }
    else
    {
        line lastL=vr[i][j][tsize-1];
        long long pos=(x.st-lastL.st)/(lastL.koef-x.koef);
        x.pos=pos;
        vr[i][j].push_back(x);
    }
}

long long query(long long i, long long j, long long pos)
{
    long long le=-1, ri=vr[i][j].size();
    if(ri==0) return -1e18;
    while(ri-le>1)
    {
        long long mid=(le+ri)/2;
        if(vr[i][j][mid].pos>=pos) le=mid;
        else ri=mid;
    }
    return vr[i][j][le].koef*pos+vr[i][j][le].st;
}

long long max_prize(std::vector<int> A)
{
    n=A.size();
    for(int i=0; i<n; i++) a[i+1]=A[i];
    Eratosten();
    for(int i=0; i<pr500; i++)
    {
        push_line(line(0, 0, 0), i, 1);
    }
    for(int i=0; i<pr500; i++) ost[i]=3%primes[i];
    for(int i=3; i<=n; i++)
    {
        dp[i]=mx[i-2]+a[i];
        if(a[i]>0)
        {
            for(int sk=pr500; primes[sk]<i && sk<brprimes; sk++)
            {
                if(dp[i]<dp[i-primes[sk]]+a[i]) dp[i]=dp[i-primes[sk]]+a[i];
            }
            for(int tp=0; tp<pr500; tp++)
            {
                long long tval=query(tp, ost[tp], a[i])+(i-ost[tp])/primes[tp]*a[i];
                if(dp[i]<tval) dp[i]=tval;
            }
        }
        for(int tp=0; tp<pr500; tp++)
        {
            push_line(line((ost[tp]-i)/primes[tp], dp[i], 0), tp, ost[tp]);
            ost[tp]++;
            if(primes[tp]==ost[tp]) ost[tp]=0;
        }
        mx[i]=max(mx[i-1], dp[i]);
    }
    return dp[n];
}
