#include<bits/stdc++.h>
#include"pacman.h"

using namespace std;

int n;
unordered_map<long long, int> ans;
int t[25][500005], lg[500005], numb[500005];

int query_max(int Le, int Ri)
{
    int gol=(Ri-Le+1), tl=lg[gol], tst2=(1<<tl);
    int id1=t[tl][Le], id2=t[tl][Ri-tst2+1];
    if(numb[id1]>numb[id2]) return id1;
    return id2;
}

void fill_table()
{
    for(int i=2; i<=n; i++) lg[i]=lg[i/2]+1;
    for(int i=1; i<=n; i++) t[0][i]=i;
    for(int lvl=1; lvl<=20; lvl++)
    {
        int st2=(1<<(lvl-1));
        for(int j=1; j<=n-st2; j++)
        {
            t[lvl][j]=t[lvl-1][j];
            if(numb[t[lvl][j]]<numb[t[lvl-1][j+st2]]) t[lvl][j]=t[lvl-1][j+st2];
        }
    }
}

stack<pair<int, int> > st;
int mx[500005]={0};
int rz[105][500005];

int solve_int(int Le, int Ri)
{
    if(Le>Ri) return 0;
    if(Le>=Ri-100) return rz[Ri-Le+1][Le];
    long long cmb=((long long)Le<<20)+Ri;
    if(ans.find(cmb)!=ans.end()) return ans[cmb];
    int val=1+max(solve_int(Le, query_max(Le, Ri)-1), solve_int(query_max(Le, Ri)+1, Ri));
    ans[cmb]=val;
    return val;
}

vector<int> qu;

long long solve(const vector<int>& w, const vector<int>& S)
{
    n=w.size();
    for(int i=0; i<n; i++) numb[i+1]=w[i];
    fill_table();

    for(int diff=1; diff<=100; diff++)
    {
        for(int L=1; L<=n-diff+1; L++)
        {
            if(diff==1)
            {
                rz[1][L]=1;
                continue;
            }
            int R=L+diff-1;
            int get_pos=query_max(L, R);
            if(get_pos==L) rz[diff][L]=1+rz[diff-1][L+1];
            else if(get_pos==R) rz[diff][L]=1+rz[diff-1][L];
            else rz[diff][L]=1+max(rz[get_pos-L][L], rz[R-get_pos][get_pos+1]);
        }
    }
    long long sum=0;

    int sz=S.size();
    for(int i=0; i<sz; i++) qu.push_back(S[i]);
    sort(qu.begin(), qu.end());
    for(int rz=0; rz<sz; rz++)
    {
        for(int i=0; i<sz-rz; i++) sum+=solve_int(qu[i], qu[i+rz]);
    }
    return sum;
}

/**
15
5 3 2 4 7 1 14 12 15 9 6 10 13 8 11

*/

