#include "jumps.h"
using namespace std;

const int MAXN = 2e5 + 5;
long long n;
long long a[MAXN];

long long rec(long long ind)
{
    if (ind < 1) return -2e9;
    if (ind == 1) return 0;
    long long ret = -2e9;

    for (long long i = ind - 1; i >= 1; i--)
    {
        long long dist = ind - i;
        for (long long t = 1; t <= dist; t++)
        {
            for (long long k = 2; k * t <= dist; k++)
            {
                if (t * k != dist) continue;
                long long tmp = rec(i) + a[ind] * t;
                ret = max(ret, tmp);
            }
        }
    }
    return ret;
}

long long max_prize(std::vector<int> A)
{
    n = A.size();
    for (long long i = 1; i <= n; i++)
        a[i] = A[i-1];

    return rec(n);
}
