#include "pacman.h"
#include <bits/stdc++.h>
using namespace std;

const int MAXN =  500000 + 5;
int n;
int w[MAXN];

void init(const std::vector<int>& _w)
{
    n = _w.size();
    for (int i = 0; i < n; i++)
        w[i+1] = _w[i];
}

int getMaxInd(int L, int R)
{
    int ind = L;
    int val = w[L];
    for (int i = L; i <= R; i++)
    {
        if (w[i] > val)
        {
            val = w[i];
            ind = i;
        }
    }
    return ind;
}

long long rec(int L, int R)
{
    if (L > R) return 0;
    if (L == R) return 1;

    long long ret = 0;
    int p = getMaxInd(L, R);

    ret = max(rec(L, p-1), rec(p+1, R));

    return ret + 1;
}

long long solveLevel(int L, int R)
{
    return rec(L, R);
}

long long solve(const std::vector<int>& w, const std::vector<int>& S)
{
    init(w);
    long long ans = 0;
    for (int i = 0; i < S.size(); i++)
    {
        for (int j = 0; j < S.size(); j++)
        {
            if (S[i] > S[j]) continue;
            long long t = solveLevel(S[i], S[j]);
            ans += t;
        }
    }
    return ans;
}
