#include<bits/stdc++.h>
#include "jumps.h"
using namespace std;
#define ll long long
const ll MAXN=2e5+6;
const ll MAXK=4;
const ll INF=2e17;
bool is_prime[MAXN];
bool p[MAXN];
ll mindiv[MAXN];
void eratosten()
{
    is_prime[2]=1;
    for(int i=2;i<MAXN;i+=2)mindiv[i]=2;
    for(ll i=3;i<MAXN;i+=2)
    {
        if(p[i]==0)
        {
            mindiv[i]=i;
            is_prime[i]=1;
            if(i<=MAXN/i)
            {
                for(ll j=i*i;j<MAXN;j+=2*i)
                {
                    if(mindiv[j]==0)mindiv[j]=i;
                    p[j]=1;
                }
            }
        }
    }
}
vector<ll>available_jumps;
ll dp[MAXN][MAXK], dp1[MAXN];
ll a1[MAXN],n;
struct line
{
    ll m,k;
    ll eval(ll x)
    {
        return m*x+k;
    }
};
double llersect(line l1,line l2)
{
    return 1.0*(l2.k-l1.k)/(l1.m-l2.m);
}
struct CHT
{
    vector<line>dq;
    CHT(){
        dq.clear();
    }
    void add(line l)
    {
        //cout<<"ughh\n";
        //cout<<dq.size()<<endl;
        if(dq.size()<2)
        {
            //cout<<"!\n";
            dq.push_back(l);
            return;
        }
        while(dq.size()>2)
        {
            if(llersect(dq[dq.size()-2], l) > llersect(dq[dq.size()-2], dq[dq.size()-1]))
            {
                dq.pop_back();
            }
            else break;
        }
        dq.push_back(l);
    }
    ll query(ll x)
    {
        if(dq.size()==0)return -INF;
        ll low=0,high=dq.size()-1,mid,ans;
        while(high-low>7)
        {
            ll mid=(low+high)/2;
            if(dq[mid].eval(x)<dq[mid+1].eval(x))
            {
                low=mid;
            }
            else
            {
                high=mid+1;
            }
        }
        ans=dq[low].eval(x);
        for(ll j=low+1;j<=high;j++)ans=max(ans,dq[j].eval(x));
        return ans;
    }
};
vector<CHT>ogi[MAXK];
long long max_prize(vector<int> __A)
{
    n=__A.size();
    for(ll i=0;i<__A.size();i++)a1[i+1]=__A[i];
    available_jumps.push_back(2);
    available_jumps.push_back(3);
    available_jumps.push_back(5);
    for(ll j=0;j<available_jumps.size();j++)
    {
        for(ll k=0;k<available_jumps[j];k++)
        {
            ogi[j].push_back(CHT());
        }
        for(ll k=0;k<available_jumps[j];k++)
        {
            ogi[j][k].dq.clear();
        }
    }
    for(ll j=0;j<available_jumps.size();j++)
    {
        dp[1][j]=0;
        ogi[j][1].add({-1/available_jumps[j],dp[1][j]});
    }
    dp1[1]=0;
    ll max1=0;
    //cout<<"eho 2\n";
    dp1[2]=-INF;
    for(ll i=3;i<=n;++i)
    {
        dp1[i]=-INF;
        for(ll j=0;j<available_jumps.size();++j)
        {
            //cout<<i<<" "<<j<<endl;
            dp[i][j]=-INF;
            if(ogi[j][i%available_jumps[j]].dq.size()!=0)
            {
                dp[i][j]=a1[i]*(i/available_jumps[j]) + ogi[j][i%available_jumps[j]].query(a1[i]);
            }
            dp1[i]=max(dp1[i],dp[i][j]);
        }
        //cout<<"**\n";
        dp1[i]=max(dp1[i],max1+a1[i]);
        max1=max(max1,dp1[i-1]);

        for(ll j=0;j<available_jumps.size();++j)
        {
            ogi[j][i%available_jumps[j]].add({-i/available_jumps[j],dp1[i]});
        }
        //cout<<i<<" "<<dp1[i]<<endl;
    }
    /*eratosten();
    for(int i=2;i<=n;i++)dp1[i]=-INF;
    for(ll i=1;i<=n;i++)
    {
        for(ll j=1;j+1<i;j++)
        {
            if(dp1[j]==-INF)continue;
            dp1[i]=max(dp1[i],dp1[j]+a1[i]*((i-j)/mindiv[i-j]));
            dp1[i]=max(dp1[i],dp1[j]+a1[i]);
        }
    }*/
    return dp1[n];
}
