#include "jumps.h"
#include<bits/stdc++.h>

using namespace std;

const int MAXN=2e5+5;

int n;
long long dp[MAXN];
int lp[MAXN];
int c[MAXN];

void precomp()
{
    lp[1]=1;
    for(int i=2;i<=n;i++)
    {
        if(!lp[i])
        {
            lp[i]=i;
            if((long long)i*i>n) continue;
            for(int j=i*i;j<=n;j+=i)
            {
                if(!lp[j]) lp[j]=i;
            }
        }
    }
    for(int i=1;i<=n;i++) c[i]=i/lp[i];
}

long long max_prize(std::vector<int> a)
{
    n=a.size();

    precomp();

    dp[0]=0;
    for(int i=1; i<n; i++)
    {
        dp[i]=a[i];
        if(a[i]>0)
        {
            for(int j=0; j<i; j++)
            {
                dp[i]=max(dp[i], dp[j]+c[i-j]*a[i]); // ll
            }
        }
        else
            for(int j=0; j<i; j++) dp[i]=max(dp[i], dp[j]+a[i]);
    }

    return dp[n-1];
}
