#include "pacman.h"
#include<bits/stdc++.h>

using namespace std;

const int MAXN=5e5+5;
const int MAXLOG=20;

int n;
vector<int> w;
vector<int> s;
int val[5005][5005];
int maxl[MAXN][MAXLOG];
int maxr[MAXN][MAXLOG];
int lg[MAXN];

int getmax(int ind1,int ind2)
{
    if(w[ind1-1]>w[ind2-1]) return ind1;
    return ind2;
}

long long num(int l,int r)
{
    return (long long)r*n+l-1;
}

void precomp()
{
    for(int i=1;i<=n;i++) val[i][i]=1;
    for(int d=2;d<=n;d++)
    {
        for(int i=1;i+d-1<=n;i++)
        {
            int mid=getmax(maxr[i][lg[d]], maxl[i+d-1][lg[d]]);
            int l=0,r=0;
            val[i][i+d-1]=1;
            if(mid>i) l=val[i][mid-1];
            if(mid<i+d-1) r=val[mid+1][i+d-1];
            val[i][i+d-1]+=max(l,r);
            //cout<<i<<" "<<d<<" "<<mid<<" "<<val[i][i+d-1]<<endl;
        }
    }
}


void spt()
{
    for(int i=1;i<=n;i++) maxl[i][0]=maxr[i][0]=i;
    for(int j=1;(1<<j)<=n;j++)
    {
        for(int i=1;i<=n;i++)
        {
            int i2=i-(1<<(j-1));
            if(i2>0) maxl[i][j]=getmax(maxl[i][j-1], maxl[i2][j-1]);
            else maxl[i][j]=maxl[i][j-1];
            i2=i+(1<<(j-1));
            if(i2<=n) maxr[i][j]=getmax(maxr[i][j-1], maxr[i2][j-1]);
            else maxr[i][j]=maxr[i][j-1];
            //cout<<i<<" "<<j<<" "<<maxl[i][j]<<" "<<maxr[i][j]<<endl;
        }
    }

    lg[1]=0;
    for(int i=2;i<=n;i++)
    {
        if(i==(1<<(lg[i-1]+1))) lg[i]=lg[i-1]+1;
        else lg[i]=lg[i-1];
    }
}

long long solve(const std::vector<int>& w1, const std::vector<int>& s1)
{
    n=w1.size();
    w=w1;
    s=s1;
    sort(s.begin(), s.end());
    spt();
    precomp();
    long long ans=0;
    for(int i=0;i<s.size();i++)
    {
        for(int j=i;j<s.size();j++)
        {
            ans+=val[s[i]][s[j]];
            //cout<<s[i]<<" "<<s[j]<<" "<<val[s[i]][s[j]]<<endl;
        }
    }
    return ans;
}
