#include <iostream>
#include "jumps.h"
using namespace std;
typedef long long ll;

const ll Size=2e5+1;
bool isnt_prime[Size];
ll primes[Size];
ll dp[Size];
ll prime_count=0;

void sieve(ll n){
    prime_count=0;
    for(ll i=2;i<=n;i++){
        if(isnt_prime[i]){
            continue;
        }
        for(ll j=i+i;j<=n;j+=i){
            isnt_prime[j]=true;
        }
    }
    for(ll i=2;i<=n;i++){
        if(!isnt_prime[i]){
            primes[prime_count]=i;
            prime_count++;
        }
    }
}

long long max_prize(std::vector<int> A){
    ll n=A.size();
    for(ll i=0;i<n;i++){
        dp[i]=-1e18;
    }
    dp[0]=0;
    sieve(n);
    for(ll i=2;i<n;i++){
        if(A[i]>=0){
            for(ll j=0;primes[j]<=i and j<prime_count;j++){
                for(ll k=1;i-primes[j]*k>=0;k++){
                    dp[i]=max(dp[i],dp[i-k*primes[j]]+k*(ll)A[i]);
                }
            }
        }else{
            for(ll j=0;primes[j]<=i and j<prime_count;j++){
                for(ll k=1;i-primes[j]*k>=0;k++){
                    dp[i]=max(dp[i],dp[i-k*primes[j]]+(ll)A[i]);
                }
            }
        }
    }
    return dp[n-1];
}
