#include <iostream>
#include "jumps.h"
using namespace std;
typedef long long ll;

const ll Size=2e5+1;
ll dp[Size];
ll l[Size];

long long max_prize(std::vector<int> A){
    ll n=A.size();
    for(ll i=0;i<n;i++){
        dp[i]=-1e18;
    }
    dp[0]=0;
    stack<pair<ll,ll>> largest;
    for(ll i=0;i<n;i++){
        while(!largest.empty() and largest.top().first<(ll)A[i]){
            largest.pop();
        }
        if(!largest.empty()){
            l[i]=largest.top().second;
        }
        largest.push({(ll)A[i],i});
    }
    for(ll i=2;i<n;i++){
        if(A[i]>=0){
            ll j=2;
            for(;j<=n;j++){
                if((i-l[i])%j==0)
                    break;
            }
            dp[i]=max(dp[i],dp[l[i]]+(i/j)*(ll)A[i]);
            if((i-l[i])%2!=0 and (i-l[i])>3){
                dp[i]=max(dp[i],dp[l[i]+3]+((i-l[i]-3)/2)*(ll)A[i]);
            }
        }else{
            for(ll j=0;j<=i;j++){
                dp[i]=max(dp[i],dp[i-j]+(ll)A[i]);
            }
        }
    }
    return dp[n-1];
}
