#include <bits/stdc++.h>
#include "pacman.h"

using namespace std;

const int MAXN = 10000;
long long dp[MAXN][MAXN];

long long res(int l, int r, const std::vector<int> &w) {
    //cout << "\t" << l << ", " << r << "\n";
    if(dp[l][r] != 0) return dp[l][r];
    int p = distance(w.begin(), max_element(w.begin() + l, w.begin() + r + 1));
    if(p == r) return 1 + res(l, p - 1, w);
    if(p == l) return 1 + res(p + 1, r, w);
    return dp[l][r] = 1 + max(res(l, p - 1, w), res(p + 1, r, w));
}

long long solve(const std::vector<int> &w, const std::vector<int> &v) {
    long long sum = 0;
    for(int i = 0; i < w.size(); i++) {
        dp[i][i] = 1;
    }
    vector<int> v1 = v;
    sort(v1.begin(), v1.end());
    for(int l = 0; l < v1.size(); l++) {
        for(int r = l; r < v1.size(); r++) {
            //cout << "(" << v[l] << "; " << v[r] << ") -> \n" << res(v[l] - 1, v[r] - 1, w) << "\n";
            sum += res(v1[l] - 1, v1[r] - 1, w);
        }
    }

    return sum;
}

