#include<iostream>
#include<vector>
#include "pacman.h"
using namespace std;

typedef int ll;

vector<int> v;
ll rem[5050][5050];
ll bin[2000200];
ll n,m,root;

void make_bin(ll pos,ll l,ll r){
  if(l==r){
    bin[pos]=l;
    return ;
    }

  ll mid=(l+r)/2;

  make_bin(pos*2,l,mid);
  make_bin(pos*2+1,mid+1,r);
  if(v[bin[pos*2]]>v[bin[pos*2+1]])bin[pos]=bin[pos*2];
  else bin[pos]=bin[pos*2+1];
  }

ll ql,qr;
ll quer(ll pos,ll l,ll r){
  if(l>qr || r<ql)return -1;
  if(l>=ql && r<=qr)return bin[pos];

  ll mid=(l+r)/2;
  ll p1=quer(pos*2,l,mid);
  ll p2=quer(pos*2+1,mid+1,r);

  if(p1==-1)return p2;
  else if(p2==-1)return p1;
  else if(p2==-1 || v[p1]>v[p2])return p1;
  else return p2;
  }

ll q(ll a,ll b){
  ql=a;
  qr=b;
  return quer(1,0,n-1);
  }

long long solve(const vector<int> w3,const vector<int> s3){
  v=w3;
  n=v.size();
  m=s3.size();

  make_bin(1,0,n-1);

  if(n<=5000){
    for(ll i=0;i<n;++i){
      for(ll j=0,pos;j<n;++j){
        if(j+i>=n)break;
        if(i+j==j)rem[j][j+i]=1;
        else {
          pos=q(j,j+i);
          if(pos!=j)rem[j][j+i]=rem[j][pos-1]+1;
          if(pos!=i+j)rem[j][j+i]=max(rem[j][j+i],rem[pos+1][j+i]+1);
          }
        //cout<<j<<" "<<j+i<<" "<<rem[j][j+i]<<endl;
        }
      }

    long long res=0,a2,a3;
    for(ll i=0;i<s3.size();++i){
      for(ll j=0;j<=i;++j){
        a2=s3[j];
        a3=s3[i];
        if(a2>a3)swap(a2,a3);
        res+=rem[a2-1][a3-1];
        }
      }
    return res;
    }
  }

  /*
int main(){

vector<int> w4,s4;
int n4,m4;

cin>>n4>>m4;
for(ll i=0,x;i<n4;++i){
  cin>>x;
  w4.push_back(x);
  }
for(ll i=0,x;i<m4;++i){
  cin>>x;
  s4.push_back(x);
  }

cout<<solve(w4,s4)<<endl;

return 0;
}
/*
4 3
1 4 2 3
1 2 4
*/
