#include<iostream>
#include "pacman.h"
using namespace std;
bool poss[5005];
int n;
int dp[3005][3005];
vector<int> v;
short tree[20005][2];
void build(int node,int l,int r)
{
    if(l==r)
    {
        tree[node][0]=v[l];
        tree[node][1]=l;
        return;
    }
    int mid=(l+r)/2;

    build(2*node,l,mid);
    build(2*node+1,mid+1,r);

    tree[node][0]=max(tree[2*node][0],tree[2*node+1][0]);

    if(tree[2*node][0]>tree[2*node+1][0])
        tree[node][1]=tree[2*node][1];
    else
        tree[node][1]=tree[2*node+1][1];
}
pair<int,int> query(int node,int l,int r,int le,int ri)
{
    if(l>ri || r<le) return {-1,0};
    if(l>=le && r<=ri)
        return {tree[node][0],tree[node][1]};

    int mid=(l+r)/2;
    pair<int,int> r1=query(2*node,l,mid,le,ri),r2=query(2*node+1,mid+1,r,le,ri);

    int rma,rpos;
    rma=max(r1.first,r2.first);

    if(r1.first>r2.first)
        rpos=r1.second;
    else
        rpos=r2.second;

    return {rma,rpos};
}
int rez(int l,int r)
{
    //cout<<l<<" "<<r<<endl;
    if(l==r)
        return dp[l][r]=1;

     if(l<=3000 && r<=3000 && dp[l][r])
        return dp[l][r];

    int maxw=0;
    int rn=0;

    pair<int,int> t=query(1,1,n,l,r);
    int p=t.second;

    if(p==l) rn=rez(l+1,r)+1;
    if(p==r) rn=rez(l,r-1)+1;

    if(p!=l && p!=r)
    rn=max(rez(l,p-1),rez(p+1,r))+1;

    return dp[l][r]=rn;
}
long long solve(const std::vector<int>& w, const std::vector<int>& S)
{
    for(int i=0;i<S.size();i++)
        poss[S[i]-1]=1;

    v=w;
    n=w.size();

    build(1,1,n-1);

    long long r=0;
    for(int i=0;i<n;i++)
    {
        for(int j=i;j<n;j++)
        {
            if(poss[i] && poss[j])
            r+=rez(i,j);
        }

    }
return r;
}

