#include<iostream>
#include "pacman.h"
using namespace std;
vector<int> v;
int n;
int tree[2000005][2];
void build(int node,int l,int r)
{
    if(l==r)
    {
        tree[node][0]=v[l];
        tree[node][1]=l;
        return;
    }
    int mid=(l+r)/2;

    build(2*node,l,mid);
    build(2*node+1,mid+1,r);

    tree[node][0]=max(tree[2*node][0],tree[2*node+1][0]);

    if(tree[2*node][0]>tree[2*node+1][0])
        tree[node][1]=tree[2*node][1];
    else
        tree[node][1]=tree[2*node+1][1];
}
pair<int,int> query(int node,int l,int r,int le,int ri)
{
    if(l>ri || r<le) return {-1,0};
    if(l>=le && r<=ri)
        return {tree[node][0],tree[node][1]};

    int mid=(l+r)/2;
    pair<int,int> r1=query(2*node,l,mid,le,ri),r2=query(2*node+1,mid+1,r,le,ri);

    int rma,rpos;
    rma=max(r1.first,r2.first);

    if(r1.first>r2.first)
        rpos=r1.second;
    else
        rpos=r2.second;

    return {rma,rpos};
}
long long rez(long long l,long long r)
{
    //cout<<l<<" "<<r<<endl;
    if(l==r)
        return 1;

    long long maxw=0;
    pair<int,int> t=query(1,1,n,l,r);
    int p=t.second;

    long long rn=0;

    if(p==l) rn=rez(l+1,r)+1;
    if(p==r) rn=rez(l,r-1)+1;

    if(p!=l && p!=r)
    rn=max(rez(l,p-1),rez(p+1,r))+1;

    return rn;
}
long long solve(const std::vector<int>& w, const std::vector<int>& S)
{
    v=w;

    long long r=0;
    n=w.size();

    build(1,1,n-1);

    for(int i=0;i<S.size();i++)
    {
        for(int j=i;j<S.size();j++)
        {
            r+=rez(min(S[i],S[j])-1,max(S[i],S[j])-1);
        }
    }
   return r;
}
