//it is your desire to work hard

#include<bits/stdc++.h>
#include "pacman.h"
#define pb push_back

using namespace std;

typedef long long ll;
typedef pair<int, int> pii;

const int maxn=5e5+3;
const int mod = 1e9+7;

int N, M;
ll a[maxn];
int tree[4*maxn];
vector<int> s;

void build(int x, int l, int r){
    if(l==r){
        tree[x]=l;
        return ;
    }
    int mid=(l+r)/2;
    build(x*2, l, mid);
    build(x*2+1, mid+1, r);

    if(a[tree[x*2]] >= a[tree[x*2+1]]){
        tree[x] = tree[x*2];
    }else{
        tree[x] = tree[x*2+1];
    }
    //cerr<<"best from "<<l<<" to "<<r<<" is "<<tree[x]<<endl;
}

int query(int x, int l, int r, int ql, int qr){
    if(ql<=l and r<=qr) return tree[x];

    int mid=(l+r)/2;

    int left=-1, right=-1;

    if(ql<=mid) left = query(x*2, l, mid, ql, qr);
    if(qr>mid) right = query(x*2+1, mid+1, r, ql, qr);

    if(left == -1){
        return right;
    }
    if(right==-1){
        return left;
    }

    if(a[left]>a[right]) return left;
    return right;
}

ll solve(const vector<int>& w, const vector<int>& S){

    for(int i=0; i<w.size(); i++){
        a[i+1]=w[i];
    }

    N=w.size();
    M=S.size();
    build(1, 1, N);

    ll nas=M;
    s.clear();
    for(auto x: S){
        s.pb(x);
    }

    sort(s.begin(), s.end());

    for(int i=0; i<M; i++){
        for(int j=i+1; j<M; j++){

            int l=s[i], r=s[j], p=0;
            //cerr<<"start "<<s[i]<<" to "<<s[j]<<endl;
            while(true){
                 if(l==r-1){
                    p+=2;
                    break;
                }

                int curr=query(1, 1, N, l, r);

                if(curr-l <= r-curr){
                    //cerr<<l<<" to "<<r<<", decided to go right"<<endl;
                    l=curr+1;
                }else{
                    //cerr<<l<<" to "<<r<<", decided to go left"<<endl;
                    r=curr-1;
                }
                p++;

            }
            //cerr<<"got "<<p<<" pts"<<endl<<endl;
            nas+=p;
        }
    }
    return nas;
}
